{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation getApplicationFees
module StripeAPI.Operations.GetApplicationFees where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > GET /v1/application_fees
--
-- \<p>Returns a list of application fees you’ve previously collected. The application fees are returned in sorted order, with the most recent fees appearing first.\<\/p>
getApplicationFees ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | Contains all available parameters of this operation (query and path parameters)
  GetApplicationFeesParameters ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.StripeT m (Network.HTTP.Client.Types.Response GetApplicationFeesResponse)
getApplicationFees parameters =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either GetApplicationFeesResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   GetApplicationFeesResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            GetApplicationFeesResponseBody200
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   GetApplicationFeesResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    ( StripeAPI.Common.doCallWithConfigurationM
        (Data.Text.toUpper GHC.Base.$ Data.Text.pack "GET")
        (Data.Text.pack "/v1/application_fees")
        [ StripeAPI.Common.QueryParameter (Data.Text.pack "charge") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getApplicationFeesParametersQueryCharge parameters) (Data.Text.pack "form") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "created") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getApplicationFeesParametersQueryCreated parameters) (Data.Text.pack "deepObject") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "ending_before") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getApplicationFeesParametersQueryEndingBefore parameters) (Data.Text.pack "form") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "expand") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getApplicationFeesParametersQueryExpand parameters) (Data.Text.pack "deepObject") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "limit") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getApplicationFeesParametersQueryLimit parameters) (Data.Text.pack "form") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "starting_after") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getApplicationFeesParametersQueryStartingAfter parameters) (Data.Text.pack "form") GHC.Types.True
        ]
    )

-- | Defines the object schema located at @paths.\/v1\/application_fees.GET.parameters@ in the specification.
data GetApplicationFeesParameters = GetApplicationFeesParameters
  { -- | queryCharge: Represents the parameter named \'charge\'
    --
    -- Only return application fees for the charge specified by this charge ID.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getApplicationFeesParametersQueryCharge :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | queryCreated: Represents the parameter named \'created\'
    getApplicationFeesParametersQueryCreated :: (GHC.Maybe.Maybe GetApplicationFeesParametersQueryCreated'Variants),
    -- | queryEnding_before: Represents the parameter named \'ending_before\'
    --
    -- A cursor for use in pagination. \`ending_before\` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with \`obj_bar\`, your subsequent call can include \`ending_before=obj_bar\` in order to fetch the previous page of the list.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getApplicationFeesParametersQueryEndingBefore :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | queryExpand: Represents the parameter named \'expand\'
    --
    -- Specifies which fields in the response should be expanded.
    getApplicationFeesParametersQueryExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | queryLimit: Represents the parameter named \'limit\'
    --
    -- A limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.
    getApplicationFeesParametersQueryLimit :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | queryStarting_after: Represents the parameter named \'starting_after\'
    --
    -- A cursor for use in pagination. \`starting_after\` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with \`obj_foo\`, your subsequent call can include \`starting_after=obj_foo\` in order to fetch the next page of the list.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getApplicationFeesParametersQueryStartingAfter :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GetApplicationFeesParameters where
  toJSON obj = Data.Aeson.Types.Internal.object ("queryCharge" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryCharge obj : "queryCreated" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryCreated obj : "queryEnding_before" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryEndingBefore obj : "queryExpand" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryExpand obj : "queryLimit" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryLimit obj : "queryStarting_after" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryStartingAfter obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("queryCharge" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryCharge obj) GHC.Base.<> (("queryCreated" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryCreated obj) GHC.Base.<> (("queryEnding_before" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryEndingBefore obj) GHC.Base.<> (("queryExpand" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryExpand obj) GHC.Base.<> (("queryLimit" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryLimit obj) GHC.Base.<> ("queryStarting_after" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryStartingAfter obj))))))

instance Data.Aeson.Types.FromJSON.FromJSON GetApplicationFeesParameters where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetApplicationFeesParameters" (\obj -> (((((GHC.Base.pure GetApplicationFeesParameters GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryCharge")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryCreated")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryEnding_before")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryExpand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryLimit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryStarting_after"))

-- | Create a new 'GetApplicationFeesParameters' with all required fields.
mkGetApplicationFeesParameters :: GetApplicationFeesParameters
mkGetApplicationFeesParameters =
  GetApplicationFeesParameters
    { getApplicationFeesParametersQueryCharge = GHC.Maybe.Nothing,
      getApplicationFeesParametersQueryCreated = GHC.Maybe.Nothing,
      getApplicationFeesParametersQueryEndingBefore = GHC.Maybe.Nothing,
      getApplicationFeesParametersQueryExpand = GHC.Maybe.Nothing,
      getApplicationFeesParametersQueryLimit = GHC.Maybe.Nothing,
      getApplicationFeesParametersQueryStartingAfter = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/application_fees.GET.parameters.properties.queryCreated.anyOf@ in the specification.
data GetApplicationFeesParametersQueryCreated'OneOf1 = GetApplicationFeesParametersQueryCreated'OneOf1
  { -- | gt
    getApplicationFeesParametersQueryCreated'OneOf1Gt :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | gte
    getApplicationFeesParametersQueryCreated'OneOf1Gte :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | lt
    getApplicationFeesParametersQueryCreated'OneOf1Lt :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | lte
    getApplicationFeesParametersQueryCreated'OneOf1Lte :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GetApplicationFeesParametersQueryCreated'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object ("gt" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryCreated'OneOf1Gt obj : "gte" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryCreated'OneOf1Gte obj : "lt" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryCreated'OneOf1Lt obj : "lte" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryCreated'OneOf1Lte obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("gt" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryCreated'OneOf1Gt obj) GHC.Base.<> (("gte" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryCreated'OneOf1Gte obj) GHC.Base.<> (("lt" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryCreated'OneOf1Lt obj) GHC.Base.<> ("lte" Data.Aeson.Types.ToJSON..= getApplicationFeesParametersQueryCreated'OneOf1Lte obj))))

instance Data.Aeson.Types.FromJSON.FromJSON GetApplicationFeesParametersQueryCreated'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetApplicationFeesParametersQueryCreated'OneOf1" (\obj -> (((GHC.Base.pure GetApplicationFeesParametersQueryCreated'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "gt")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "gte")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "lt")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "lte"))

-- | Create a new 'GetApplicationFeesParametersQueryCreated'OneOf1' with all required fields.
mkGetApplicationFeesParametersQueryCreated'OneOf1 :: GetApplicationFeesParametersQueryCreated'OneOf1
mkGetApplicationFeesParametersQueryCreated'OneOf1 =
  GetApplicationFeesParametersQueryCreated'OneOf1
    { getApplicationFeesParametersQueryCreated'OneOf1Gt = GHC.Maybe.Nothing,
      getApplicationFeesParametersQueryCreated'OneOf1Gte = GHC.Maybe.Nothing,
      getApplicationFeesParametersQueryCreated'OneOf1Lt = GHC.Maybe.Nothing,
      getApplicationFeesParametersQueryCreated'OneOf1Lte = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/application_fees.GET.parameters.properties.queryCreated.anyOf@ in the specification.
--
-- Represents the parameter named \'created\'
data GetApplicationFeesParametersQueryCreated'Variants
  = GetApplicationFeesParametersQueryCreated'GetApplicationFeesParametersQueryCreated'OneOf1 GetApplicationFeesParametersQueryCreated'OneOf1
  | GetApplicationFeesParametersQueryCreated'Int GHC.Types.Int
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON GetApplicationFeesParametersQueryCreated'Variants where
  toJSON (GetApplicationFeesParametersQueryCreated'GetApplicationFeesParametersQueryCreated'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (GetApplicationFeesParametersQueryCreated'Int a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON GetApplicationFeesParametersQueryCreated'Variants where
  parseJSON val = case (GetApplicationFeesParametersQueryCreated'GetApplicationFeesParametersQueryCreated'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((GetApplicationFeesParametersQueryCreated'Int Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Represents a response of the operation 'getApplicationFees'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'GetApplicationFeesResponseError' is used.
data GetApplicationFeesResponse
  = -- | Means either no matching case available or a parse error
    GetApplicationFeesResponseError GHC.Base.String
  | -- | Successful response.
    GetApplicationFeesResponse200 GetApplicationFeesResponseBody200
  | -- | Error response.
    GetApplicationFeesResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)

-- | Defines the object schema located at @paths.\/v1\/application_fees.GET.responses.200.content.application\/json.schema@ in the specification.
data GetApplicationFeesResponseBody200 = GetApplicationFeesResponseBody200
  { -- | data
    getApplicationFeesResponseBody200Data :: ([ApplicationFee]),
    -- | has_more: True if this list has another page of items after this one that can be fetched.
    getApplicationFeesResponseBody200HasMore :: GHC.Types.Bool,
    -- | url: The URL where this list can be accessed.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    -- * Must match pattern \'^\/v1\/application_fees\'
    getApplicationFeesResponseBody200Url :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GetApplicationFeesResponseBody200 where
  toJSON obj = Data.Aeson.Types.Internal.object ("data" Data.Aeson.Types.ToJSON..= getApplicationFeesResponseBody200Data obj : "has_more" Data.Aeson.Types.ToJSON..= getApplicationFeesResponseBody200HasMore obj : "url" Data.Aeson.Types.ToJSON..= getApplicationFeesResponseBody200Url obj : "object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "list" : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("data" Data.Aeson.Types.ToJSON..= getApplicationFeesResponseBody200Data obj) GHC.Base.<> (("has_more" Data.Aeson.Types.ToJSON..= getApplicationFeesResponseBody200HasMore obj) GHC.Base.<> (("url" Data.Aeson.Types.ToJSON..= getApplicationFeesResponseBody200Url obj) GHC.Base.<> ("object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "list"))))

instance Data.Aeson.Types.FromJSON.FromJSON GetApplicationFeesResponseBody200 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetApplicationFeesResponseBody200" (\obj -> ((GHC.Base.pure GetApplicationFeesResponseBody200 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "has_more")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "url"))

-- | Create a new 'GetApplicationFeesResponseBody200' with all required fields.
mkGetApplicationFeesResponseBody200 ::
  -- | 'getApplicationFeesResponseBody200Data'
  [ApplicationFee] ->
  -- | 'getApplicationFeesResponseBody200HasMore'
  GHC.Types.Bool ->
  -- | 'getApplicationFeesResponseBody200Url'
  Data.Text.Internal.Text ->
  GetApplicationFeesResponseBody200
mkGetApplicationFeesResponseBody200 getApplicationFeesResponseBody200Data getApplicationFeesResponseBody200HasMore getApplicationFeesResponseBody200Url =
  GetApplicationFeesResponseBody200
    { getApplicationFeesResponseBody200Data = getApplicationFeesResponseBody200Data,
      getApplicationFeesResponseBody200HasMore = getApplicationFeesResponseBody200HasMore,
      getApplicationFeesResponseBody200Url = getApplicationFeesResponseBody200Url
    }
