{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation getSkus
module StripeAPI.Operations.GetSkus where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > GET /v1/skus
--
-- \<p>Returns a list of your SKUs. The SKUs are returned sorted by creation date, with the most recently created SKUs appearing first.\<\/p>
getSkus ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | Contains all available parameters of this operation (query and path parameters)
  GetSkusParameters ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.StripeT m (Network.HTTP.Client.Types.Response GetSkusResponse)
getSkus parameters =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either GetSkusResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   GetSkusResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            GetSkusResponseBody200
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   GetSkusResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    ( StripeAPI.Common.doCallWithConfigurationM
        (Data.Text.toUpper GHC.Base.$ Data.Text.pack "GET")
        (Data.Text.pack "/v1/skus")
        [ StripeAPI.Common.QueryParameter (Data.Text.pack "active") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getSkusParametersQueryActive parameters) (Data.Text.pack "form") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "attributes") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getSkusParametersQueryAttributes parameters) (Data.Text.pack "deepObject") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "ending_before") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getSkusParametersQueryEndingBefore parameters) (Data.Text.pack "form") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "expand") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getSkusParametersQueryExpand parameters) (Data.Text.pack "deepObject") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "ids") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getSkusParametersQueryIds parameters) (Data.Text.pack "deepObject") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "in_stock") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getSkusParametersQueryInStock parameters) (Data.Text.pack "form") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "limit") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getSkusParametersQueryLimit parameters) (Data.Text.pack "form") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "product") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getSkusParametersQueryProduct parameters) (Data.Text.pack "form") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "starting_after") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getSkusParametersQueryStartingAfter parameters) (Data.Text.pack "form") GHC.Types.True
        ]
    )

-- | Defines the object schema located at @paths.\/v1\/skus.GET.parameters@ in the specification.
data GetSkusParameters = GetSkusParameters
  { -- | queryActive: Represents the parameter named \'active\'
    --
    -- Only return SKUs that are active or inactive (e.g., pass \`false\` to list all inactive products).
    getSkusParametersQueryActive :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | queryAttributes: Represents the parameter named \'attributes\'
    --
    -- Only return SKUs that have the specified key-value pairs in this partially constructed dictionary. Can be specified only if \`product\` is also supplied. For instance, if the associated product has attributes \`[\"color\", \"size\"]\`, passing in \`attributes[color]=red\` returns all the SKUs for this product that have \`color\` set to \`red\`.
    getSkusParametersQueryAttributes :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | queryEnding_before: Represents the parameter named \'ending_before\'
    --
    -- A cursor for use in pagination. \`ending_before\` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with \`obj_bar\`, your subsequent call can include \`ending_before=obj_bar\` in order to fetch the previous page of the list.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getSkusParametersQueryEndingBefore :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | queryExpand: Represents the parameter named \'expand\'
    --
    -- Specifies which fields in the response should be expanded.
    getSkusParametersQueryExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | queryIds: Represents the parameter named \'ids\'
    --
    -- Only return SKUs with the given IDs.
    getSkusParametersQueryIds :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | queryIn_stock: Represents the parameter named \'in_stock\'
    --
    -- Only return SKUs that are either in stock or out of stock (e.g., pass \`false\` to list all SKUs that are out of stock). If no value is provided, all SKUs are returned.
    getSkusParametersQueryInStock :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | queryLimit: Represents the parameter named \'limit\'
    --
    -- A limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.
    getSkusParametersQueryLimit :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | queryProduct: Represents the parameter named \'product\'
    --
    -- The ID of the product whose SKUs will be retrieved. Must be a product with type \`good\`.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getSkusParametersQueryProduct :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | queryStarting_after: Represents the parameter named \'starting_after\'
    --
    -- A cursor for use in pagination. \`starting_after\` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with \`obj_foo\`, your subsequent call can include \`starting_after=obj_foo\` in order to fetch the next page of the list.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getSkusParametersQueryStartingAfter :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GetSkusParameters where
  toJSON obj = Data.Aeson.Types.Internal.object ("queryActive" Data.Aeson.Types.ToJSON..= getSkusParametersQueryActive obj : "queryAttributes" Data.Aeson.Types.ToJSON..= getSkusParametersQueryAttributes obj : "queryEnding_before" Data.Aeson.Types.ToJSON..= getSkusParametersQueryEndingBefore obj : "queryExpand" Data.Aeson.Types.ToJSON..= getSkusParametersQueryExpand obj : "queryIds" Data.Aeson.Types.ToJSON..= getSkusParametersQueryIds obj : "queryIn_stock" Data.Aeson.Types.ToJSON..= getSkusParametersQueryInStock obj : "queryLimit" Data.Aeson.Types.ToJSON..= getSkusParametersQueryLimit obj : "queryProduct" Data.Aeson.Types.ToJSON..= getSkusParametersQueryProduct obj : "queryStarting_after" Data.Aeson.Types.ToJSON..= getSkusParametersQueryStartingAfter obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("queryActive" Data.Aeson.Types.ToJSON..= getSkusParametersQueryActive obj) GHC.Base.<> (("queryAttributes" Data.Aeson.Types.ToJSON..= getSkusParametersQueryAttributes obj) GHC.Base.<> (("queryEnding_before" Data.Aeson.Types.ToJSON..= getSkusParametersQueryEndingBefore obj) GHC.Base.<> (("queryExpand" Data.Aeson.Types.ToJSON..= getSkusParametersQueryExpand obj) GHC.Base.<> (("queryIds" Data.Aeson.Types.ToJSON..= getSkusParametersQueryIds obj) GHC.Base.<> (("queryIn_stock" Data.Aeson.Types.ToJSON..= getSkusParametersQueryInStock obj) GHC.Base.<> (("queryLimit" Data.Aeson.Types.ToJSON..= getSkusParametersQueryLimit obj) GHC.Base.<> (("queryProduct" Data.Aeson.Types.ToJSON..= getSkusParametersQueryProduct obj) GHC.Base.<> ("queryStarting_after" Data.Aeson.Types.ToJSON..= getSkusParametersQueryStartingAfter obj)))))))))

instance Data.Aeson.Types.FromJSON.FromJSON GetSkusParameters where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetSkusParameters" (\obj -> ((((((((GHC.Base.pure GetSkusParameters GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryActive")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryAttributes")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryEnding_before")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryExpand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryIds")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryIn_stock")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryLimit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryProduct")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryStarting_after"))

-- | Create a new 'GetSkusParameters' with all required fields.
mkGetSkusParameters :: GetSkusParameters
mkGetSkusParameters =
  GetSkusParameters
    { getSkusParametersQueryActive = GHC.Maybe.Nothing,
      getSkusParametersQueryAttributes = GHC.Maybe.Nothing,
      getSkusParametersQueryEndingBefore = GHC.Maybe.Nothing,
      getSkusParametersQueryExpand = GHC.Maybe.Nothing,
      getSkusParametersQueryIds = GHC.Maybe.Nothing,
      getSkusParametersQueryInStock = GHC.Maybe.Nothing,
      getSkusParametersQueryLimit = GHC.Maybe.Nothing,
      getSkusParametersQueryProduct = GHC.Maybe.Nothing,
      getSkusParametersQueryStartingAfter = GHC.Maybe.Nothing
    }

-- | Represents a response of the operation 'getSkus'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'GetSkusResponseError' is used.
data GetSkusResponse
  = -- | Means either no matching case available or a parse error
    GetSkusResponseError GHC.Base.String
  | -- | Successful response.
    GetSkusResponse200 GetSkusResponseBody200
  | -- | Error response.
    GetSkusResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)

-- | Defines the object schema located at @paths.\/v1\/skus.GET.responses.200.content.application\/json.schema@ in the specification.
data GetSkusResponseBody200 = GetSkusResponseBody200
  { -- | data
    getSkusResponseBody200Data :: ([Sku]),
    -- | has_more: True if this list has another page of items after this one that can be fetched.
    getSkusResponseBody200HasMore :: GHC.Types.Bool,
    -- | url: The URL where this list can be accessed.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    -- * Must match pattern \'^\/v1\/skus\'
    getSkusResponseBody200Url :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GetSkusResponseBody200 where
  toJSON obj = Data.Aeson.Types.Internal.object ("data" Data.Aeson.Types.ToJSON..= getSkusResponseBody200Data obj : "has_more" Data.Aeson.Types.ToJSON..= getSkusResponseBody200HasMore obj : "url" Data.Aeson.Types.ToJSON..= getSkusResponseBody200Url obj : "object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "list" : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("data" Data.Aeson.Types.ToJSON..= getSkusResponseBody200Data obj) GHC.Base.<> (("has_more" Data.Aeson.Types.ToJSON..= getSkusResponseBody200HasMore obj) GHC.Base.<> (("url" Data.Aeson.Types.ToJSON..= getSkusResponseBody200Url obj) GHC.Base.<> ("object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "list"))))

instance Data.Aeson.Types.FromJSON.FromJSON GetSkusResponseBody200 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetSkusResponseBody200" (\obj -> ((GHC.Base.pure GetSkusResponseBody200 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "has_more")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "url"))

-- | Create a new 'GetSkusResponseBody200' with all required fields.
mkGetSkusResponseBody200 ::
  -- | 'getSkusResponseBody200Data'
  [Sku] ->
  -- | 'getSkusResponseBody200HasMore'
  GHC.Types.Bool ->
  -- | 'getSkusResponseBody200Url'
  Data.Text.Internal.Text ->
  GetSkusResponseBody200
mkGetSkusResponseBody200 getSkusResponseBody200Data getSkusResponseBody200HasMore getSkusResponseBody200Url =
  GetSkusResponseBody200
    { getSkusResponseBody200Data = getSkusResponseBody200Data,
      getSkusResponseBody200HasMore = getSkusResponseBody200HasMore,
      getSkusResponseBody200Url = getSkusResponseBody200Url
    }
