{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation getTopupsTopup
module StripeAPI.Operations.GetTopupsTopup where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > GET /v1/topups/{topup}
--
-- \<p>Retrieves the details of a top-up that has previously been created. Supply the unique top-up ID that was returned from your previous request, and Stripe will return the corresponding top-up information.\<\/p>
getTopupsTopup ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | Contains all available parameters of this operation (query and path parameters)
  GetTopupsTopupParameters ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.StripeT m (Network.HTTP.Client.Types.Response GetTopupsTopupResponse)
getTopupsTopup parameters =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either GetTopupsTopupResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   GetTopupsTopupResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Topup
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   GetTopupsTopupResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    (StripeAPI.Common.doCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "GET") (Data.Text.pack ("/v1/topups/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel (getTopupsTopupParametersPathTopup parameters))) GHC.Base.++ ""))) [StripeAPI.Common.QueryParameter (Data.Text.pack "expand") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getTopupsTopupParametersQueryExpand parameters) (Data.Text.pack "deepObject") GHC.Types.True])

-- | Defines the object schema located at @paths.\/v1\/topups\/{topup}.GET.parameters@ in the specification.
data GetTopupsTopupParameters = GetTopupsTopupParameters
  { -- | pathTopup: Represents the parameter named \'topup\'
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getTopupsTopupParametersPathTopup :: Data.Text.Internal.Text,
    -- | queryExpand: Represents the parameter named \'expand\'
    --
    -- Specifies which fields in the response should be expanded.
    getTopupsTopupParametersQueryExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text]))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GetTopupsTopupParameters where
  toJSON obj = Data.Aeson.Types.Internal.object ("pathTopup" Data.Aeson.Types.ToJSON..= getTopupsTopupParametersPathTopup obj : "queryExpand" Data.Aeson.Types.ToJSON..= getTopupsTopupParametersQueryExpand obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("pathTopup" Data.Aeson.Types.ToJSON..= getTopupsTopupParametersPathTopup obj) GHC.Base.<> ("queryExpand" Data.Aeson.Types.ToJSON..= getTopupsTopupParametersQueryExpand obj))

instance Data.Aeson.Types.FromJSON.FromJSON GetTopupsTopupParameters where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetTopupsTopupParameters" (\obj -> (GHC.Base.pure GetTopupsTopupParameters GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "pathTopup")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "queryExpand"))

-- | Create a new 'GetTopupsTopupParameters' with all required fields.
mkGetTopupsTopupParameters ::
  -- | 'getTopupsTopupParametersPathTopup'
  Data.Text.Internal.Text ->
  GetTopupsTopupParameters
mkGetTopupsTopupParameters getTopupsTopupParametersPathTopup =
  GetTopupsTopupParameters
    { getTopupsTopupParametersPathTopup = getTopupsTopupParametersPathTopup,
      getTopupsTopupParametersQueryExpand = GHC.Maybe.Nothing
    }

-- | Represents a response of the operation 'getTopupsTopup'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'GetTopupsTopupResponseError' is used.
data GetTopupsTopupResponse
  = -- | Means either no matching case available or a parse error
    GetTopupsTopupResponseError GHC.Base.String
  | -- | Successful response.
    GetTopupsTopupResponse200 Topup
  | -- | Error response.
    GetTopupsTopupResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
