{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postTaxRatesTaxRate
module StripeAPI.Operations.PostTaxRatesTaxRate where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/tax_rates/{tax_rate}
--
-- \<p>Updates an existing tax rate.\<\/p>
postTaxRatesTaxRate ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | tax_rate | Constraints: Maximum length of 5000
  Data.Text.Internal.Text ->
  -- | The request body to send
  GHC.Maybe.Maybe PostTaxRatesTaxRateRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.StripeT m (Network.HTTP.Client.Types.Response PostTaxRatesTaxRateResponse)
postTaxRatesTaxRate
  taxRate
  body =
    GHC.Base.fmap
      ( \response_0 ->
          GHC.Base.fmap
            ( Data.Either.either PostTaxRatesTaxRateResponseError GHC.Base.id
                GHC.Base.. ( \response body ->
                               if
                                   | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostTaxRatesTaxRateResponse200
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              TaxRate
                                                        )
                                   | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostTaxRatesTaxRateResponseDefault
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Error
                                                        )
                                   | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                           )
                  response_0
            )
            response_0
      )
      (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack ("/v1/tax_rates/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel taxRate)) GHC.Base.++ ""))) GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/tax_rates\/{tax_rate}.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostTaxRatesTaxRateRequestBody = PostTaxRatesTaxRateRequestBody
  { -- | active: Flag determining whether the tax rate is active or inactive (archived). Inactive tax rates cannot be used with new applications or Checkout Sessions, but will still work for subscriptions and invoices that already have it set.
    postTaxRatesTaxRateRequestBodyActive :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | country: Two-letter country code ([ISO 3166-1 alpha-2](https:\/\/en.wikipedia.org\/wiki\/ISO_3166-1_alpha-2)).
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postTaxRatesTaxRateRequestBodyCountry :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | description: An arbitrary string attached to the tax rate for your internal use only. It will not be visible to your customers.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postTaxRatesTaxRateRequestBodyDescription :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | display_name: The display name of the tax rate, which will be shown to users.
    --
    -- Constraints:
    --
    -- * Maximum length of 50
    postTaxRatesTaxRateRequestBodyDisplayName :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | expand: Specifies which fields in the response should be expanded.
    postTaxRatesTaxRateRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | jurisdiction: The jurisdiction for the tax rate. You can use this label field for tax reporting purposes. It also appears on your customer’s invoice.
    --
    -- Constraints:
    --
    -- * Maximum length of 50
    postTaxRatesTaxRateRequestBodyJurisdiction :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
    postTaxRatesTaxRateRequestBodyMetadata :: (GHC.Maybe.Maybe PostTaxRatesTaxRateRequestBodyMetadata'Variants),
    -- | state: [ISO 3166-2 subdivision code](https:\/\/en.wikipedia.org\/wiki\/ISO_3166-2:US), without country prefix. For example, \"NY\" for New York, United States.
    --
    -- Constraints:
    --
    -- * Maximum length of 2
    postTaxRatesTaxRateRequestBodyState :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | tax_type: The high-level tax type, such as \`vat\` or \`sales_tax\`.
    postTaxRatesTaxRateRequestBodyTaxType :: (GHC.Maybe.Maybe PostTaxRatesTaxRateRequestBodyTaxType')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTaxRatesTaxRateRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object ("active" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyActive obj : "country" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyCountry obj : "description" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyDescription obj : "display_name" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyDisplayName obj : "expand" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyExpand obj : "jurisdiction" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyJurisdiction obj : "metadata" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyMetadata obj : "state" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyState obj : "tax_type" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyTaxType obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("active" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyActive obj) GHC.Base.<> (("country" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyCountry obj) GHC.Base.<> (("description" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyDescription obj) GHC.Base.<> (("display_name" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyDisplayName obj) GHC.Base.<> (("expand" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyExpand obj) GHC.Base.<> (("jurisdiction" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyJurisdiction obj) GHC.Base.<> (("metadata" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyMetadata obj) GHC.Base.<> (("state" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyState obj) GHC.Base.<> ("tax_type" Data.Aeson.Types.ToJSON..= postTaxRatesTaxRateRequestBodyTaxType obj)))))))))

instance Data.Aeson.Types.FromJSON.FromJSON PostTaxRatesTaxRateRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTaxRatesTaxRateRequestBody" (\obj -> ((((((((GHC.Base.pure PostTaxRatesTaxRateRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "active")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "country")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "display_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "jurisdiction")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "state")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "tax_type"))

-- | Create a new 'PostTaxRatesTaxRateRequestBody' with all required fields.
mkPostTaxRatesTaxRateRequestBody :: PostTaxRatesTaxRateRequestBody
mkPostTaxRatesTaxRateRequestBody =
  PostTaxRatesTaxRateRequestBody
    { postTaxRatesTaxRateRequestBodyActive = GHC.Maybe.Nothing,
      postTaxRatesTaxRateRequestBodyCountry = GHC.Maybe.Nothing,
      postTaxRatesTaxRateRequestBodyDescription = GHC.Maybe.Nothing,
      postTaxRatesTaxRateRequestBodyDisplayName = GHC.Maybe.Nothing,
      postTaxRatesTaxRateRequestBodyExpand = GHC.Maybe.Nothing,
      postTaxRatesTaxRateRequestBodyJurisdiction = GHC.Maybe.Nothing,
      postTaxRatesTaxRateRequestBodyMetadata = GHC.Maybe.Nothing,
      postTaxRatesTaxRateRequestBodyState = GHC.Maybe.Nothing,
      postTaxRatesTaxRateRequestBodyTaxType = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/tax_rates\/{tax_rate}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.metadata.anyOf@ in the specification.
--
-- Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
data PostTaxRatesTaxRateRequestBodyMetadata'Variants
  = -- | Represents the JSON value @""@
    PostTaxRatesTaxRateRequestBodyMetadata'EmptyString
  | PostTaxRatesTaxRateRequestBodyMetadata'Object Data.Aeson.Types.Internal.Object
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTaxRatesTaxRateRequestBodyMetadata'Variants where
  toJSON (PostTaxRatesTaxRateRequestBodyMetadata'Object a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostTaxRatesTaxRateRequestBodyMetadata'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostTaxRatesTaxRateRequestBodyMetadata'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostTaxRatesTaxRateRequestBodyMetadata'EmptyString
        | GHC.Base.otherwise -> case (PostTaxRatesTaxRateRequestBodyMetadata'Object Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the enum schema located at @paths.\/v1\/tax_rates\/{tax_rate}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tax_type@ in the specification.
--
-- The high-level tax type, such as \`vat\` or \`sales_tax\`.
data PostTaxRatesTaxRateRequestBodyTaxType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostTaxRatesTaxRateRequestBodyTaxType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostTaxRatesTaxRateRequestBodyTaxType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"gst"@
    PostTaxRatesTaxRateRequestBodyTaxType'EnumGst
  | -- | Represents the JSON value @"hst"@
    PostTaxRatesTaxRateRequestBodyTaxType'EnumHst
  | -- | Represents the JSON value @"pst"@
    PostTaxRatesTaxRateRequestBodyTaxType'EnumPst
  | -- | Represents the JSON value @"qst"@
    PostTaxRatesTaxRateRequestBodyTaxType'EnumQst
  | -- | Represents the JSON value @"sales_tax"@
    PostTaxRatesTaxRateRequestBodyTaxType'EnumSalesTax
  | -- | Represents the JSON value @"vat"@
    PostTaxRatesTaxRateRequestBodyTaxType'EnumVat
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTaxRatesTaxRateRequestBodyTaxType' where
  toJSON (PostTaxRatesTaxRateRequestBodyTaxType'Other val) = val
  toJSON (PostTaxRatesTaxRateRequestBodyTaxType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostTaxRatesTaxRateRequestBodyTaxType'EnumGst) = "gst"
  toJSON (PostTaxRatesTaxRateRequestBodyTaxType'EnumHst) = "hst"
  toJSON (PostTaxRatesTaxRateRequestBodyTaxType'EnumPst) = "pst"
  toJSON (PostTaxRatesTaxRateRequestBodyTaxType'EnumQst) = "qst"
  toJSON (PostTaxRatesTaxRateRequestBodyTaxType'EnumSalesTax) = "sales_tax"
  toJSON (PostTaxRatesTaxRateRequestBodyTaxType'EnumVat) = "vat"

instance Data.Aeson.Types.FromJSON.FromJSON PostTaxRatesTaxRateRequestBodyTaxType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "gst" -> PostTaxRatesTaxRateRequestBodyTaxType'EnumGst
            | val GHC.Classes.== "hst" -> PostTaxRatesTaxRateRequestBodyTaxType'EnumHst
            | val GHC.Classes.== "pst" -> PostTaxRatesTaxRateRequestBodyTaxType'EnumPst
            | val GHC.Classes.== "qst" -> PostTaxRatesTaxRateRequestBodyTaxType'EnumQst
            | val GHC.Classes.== "sales_tax" -> PostTaxRatesTaxRateRequestBodyTaxType'EnumSalesTax
            | val GHC.Classes.== "vat" -> PostTaxRatesTaxRateRequestBodyTaxType'EnumVat
            | GHC.Base.otherwise -> PostTaxRatesTaxRateRequestBodyTaxType'Other val
      )

-- | Represents a response of the operation 'postTaxRatesTaxRate'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostTaxRatesTaxRateResponseError' is used.
data PostTaxRatesTaxRateResponse
  = -- | Means either no matching case available or a parse error
    PostTaxRatesTaxRateResponseError GHC.Base.String
  | -- | Successful response.
    PostTaxRatesTaxRateResponse200 TaxRate
  | -- | Error response.
    PostTaxRatesTaxRateResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
