{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postWebhookEndpointsWebhookEndpoint
module StripeAPI.Operations.PostWebhookEndpointsWebhookEndpoint where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/webhook_endpoints/{webhook_endpoint}
--
-- \<p>Updates the webhook endpoint. You may edit the \<code>url\<\/code>, the list of \<code>enabled_events\<\/code>, and the status of your endpoint.\<\/p>
postWebhookEndpointsWebhookEndpoint ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | webhook_endpoint | Constraints: Maximum length of 5000
  Data.Text.Internal.Text ->
  -- | The request body to send
  GHC.Maybe.Maybe PostWebhookEndpointsWebhookEndpointRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.StripeT m (Network.HTTP.Client.Types.Response PostWebhookEndpointsWebhookEndpointResponse)
postWebhookEndpointsWebhookEndpoint
  webhookEndpoint
  body =
    GHC.Base.fmap
      ( \response_0 ->
          GHC.Base.fmap
            ( Data.Either.either PostWebhookEndpointsWebhookEndpointResponseError GHC.Base.id
                GHC.Base.. ( \response body ->
                               if
                                   | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostWebhookEndpointsWebhookEndpointResponse200
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              WebhookEndpoint
                                                        )
                                   | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostWebhookEndpointsWebhookEndpointResponseDefault
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Error
                                                        )
                                   | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                           )
                  response_0
            )
            response_0
      )
      (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack ("/v1/webhook_endpoints/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel webhookEndpoint)) GHC.Base.++ ""))) GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/webhook_endpoints\/{webhook_endpoint}.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostWebhookEndpointsWebhookEndpointRequestBody = PostWebhookEndpointsWebhookEndpointRequestBody
  { -- | description: An optional description of what the webhook is used for.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postWebhookEndpointsWebhookEndpointRequestBodyDescription :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | disabled: Disable the webhook endpoint if set to true.
    postWebhookEndpointsWebhookEndpointRequestBodyDisabled :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | enabled_events: The list of events to enable for this endpoint. You may specify \`[\'*\']\` to enable all events, except those that require explicit selection.
    postWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents :: (GHC.Maybe.Maybe ([PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'])),
    -- | expand: Specifies which fields in the response should be expanded.
    postWebhookEndpointsWebhookEndpointRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
    postWebhookEndpointsWebhookEndpointRequestBodyMetadata :: (GHC.Maybe.Maybe PostWebhookEndpointsWebhookEndpointRequestBodyMetadata'Variants),
    -- | url: The URL of the webhook endpoint.
    postWebhookEndpointsWebhookEndpointRequestBodyUrl :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostWebhookEndpointsWebhookEndpointRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object ("description" Data.Aeson.Types.ToJSON..= postWebhookEndpointsWebhookEndpointRequestBodyDescription obj : "disabled" Data.Aeson.Types.ToJSON..= postWebhookEndpointsWebhookEndpointRequestBodyDisabled obj : "enabled_events" Data.Aeson.Types.ToJSON..= postWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents obj : "expand" Data.Aeson.Types.ToJSON..= postWebhookEndpointsWebhookEndpointRequestBodyExpand obj : "metadata" Data.Aeson.Types.ToJSON..= postWebhookEndpointsWebhookEndpointRequestBodyMetadata obj : "url" Data.Aeson.Types.ToJSON..= postWebhookEndpointsWebhookEndpointRequestBodyUrl obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("description" Data.Aeson.Types.ToJSON..= postWebhookEndpointsWebhookEndpointRequestBodyDescription obj) GHC.Base.<> (("disabled" Data.Aeson.Types.ToJSON..= postWebhookEndpointsWebhookEndpointRequestBodyDisabled obj) GHC.Base.<> (("enabled_events" Data.Aeson.Types.ToJSON..= postWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents obj) GHC.Base.<> (("expand" Data.Aeson.Types.ToJSON..= postWebhookEndpointsWebhookEndpointRequestBodyExpand obj) GHC.Base.<> (("metadata" Data.Aeson.Types.ToJSON..= postWebhookEndpointsWebhookEndpointRequestBodyMetadata obj) GHC.Base.<> ("url" Data.Aeson.Types.ToJSON..= postWebhookEndpointsWebhookEndpointRequestBodyUrl obj))))))

instance Data.Aeson.Types.FromJSON.FromJSON PostWebhookEndpointsWebhookEndpointRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostWebhookEndpointsWebhookEndpointRequestBody" (\obj -> (((((GHC.Base.pure PostWebhookEndpointsWebhookEndpointRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "description")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "disabled")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "enabled_events")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "url"))

-- | Create a new 'PostWebhookEndpointsWebhookEndpointRequestBody' with all required fields.
mkPostWebhookEndpointsWebhookEndpointRequestBody :: PostWebhookEndpointsWebhookEndpointRequestBody
mkPostWebhookEndpointsWebhookEndpointRequestBody =
  PostWebhookEndpointsWebhookEndpointRequestBody
    { postWebhookEndpointsWebhookEndpointRequestBodyDescription = GHC.Maybe.Nothing,
      postWebhookEndpointsWebhookEndpointRequestBodyDisabled = GHC.Maybe.Nothing,
      postWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents = GHC.Maybe.Nothing,
      postWebhookEndpointsWebhookEndpointRequestBodyExpand = GHC.Maybe.Nothing,
      postWebhookEndpointsWebhookEndpointRequestBodyMetadata = GHC.Maybe.Nothing,
      postWebhookEndpointsWebhookEndpointRequestBodyUrl = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/webhook_endpoints\/{webhook_endpoint}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.enabled_events.items@ in the specification.
data PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"*"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'Enum_
  | -- | Represents the JSON value @"account.application.authorized"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'application'authorized
  | -- | Represents the JSON value @"account.application.deauthorized"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'application'deauthorized
  | -- | Represents the JSON value @"account.external_account.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'externalAccount'created
  | -- | Represents the JSON value @"account.external_account.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'externalAccount'deleted
  | -- | Represents the JSON value @"account.external_account.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'externalAccount'updated
  | -- | Represents the JSON value @"account.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'updated
  | -- | Represents the JSON value @"application_fee.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumApplicationFee'created
  | -- | Represents the JSON value @"application_fee.refund.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumApplicationFee'refund'updated
  | -- | Represents the JSON value @"application_fee.refunded"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumApplicationFee'refunded
  | -- | Represents the JSON value @"balance.available"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumBalance'available
  | -- | Represents the JSON value @"billing_portal.configuration.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumBillingPortal'configuration'created
  | -- | Represents the JSON value @"billing_portal.configuration.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumBillingPortal'configuration'updated
  | -- | Represents the JSON value @"capability.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCapability'updated
  | -- | Represents the JSON value @"charge.captured"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'captured
  | -- | Represents the JSON value @"charge.dispute.closed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'closed
  | -- | Represents the JSON value @"charge.dispute.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'created
  | -- | Represents the JSON value @"charge.dispute.funds_reinstated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'fundsReinstated
  | -- | Represents the JSON value @"charge.dispute.funds_withdrawn"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'fundsWithdrawn
  | -- | Represents the JSON value @"charge.dispute.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'updated
  | -- | Represents the JSON value @"charge.expired"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'expired
  | -- | Represents the JSON value @"charge.failed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'failed
  | -- | Represents the JSON value @"charge.pending"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'pending
  | -- | Represents the JSON value @"charge.refund.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'refund'updated
  | -- | Represents the JSON value @"charge.refunded"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'refunded
  | -- | Represents the JSON value @"charge.succeeded"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'succeeded
  | -- | Represents the JSON value @"charge.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'updated
  | -- | Represents the JSON value @"checkout.session.async_payment_failed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCheckout'session'asyncPaymentFailed
  | -- | Represents the JSON value @"checkout.session.async_payment_succeeded"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCheckout'session'asyncPaymentSucceeded
  | -- | Represents the JSON value @"checkout.session.completed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCheckout'session'completed
  | -- | Represents the JSON value @"coupon.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCoupon'created
  | -- | Represents the JSON value @"coupon.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCoupon'deleted
  | -- | Represents the JSON value @"coupon.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCoupon'updated
  | -- | Represents the JSON value @"credit_note.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCreditNote'created
  | -- | Represents the JSON value @"credit_note.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCreditNote'updated
  | -- | Represents the JSON value @"credit_note.voided"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCreditNote'voided
  | -- | Represents the JSON value @"customer.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'created
  | -- | Represents the JSON value @"customer.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'deleted
  | -- | Represents the JSON value @"customer.discount.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'discount'created
  | -- | Represents the JSON value @"customer.discount.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'discount'deleted
  | -- | Represents the JSON value @"customer.discount.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'discount'updated
  | -- | Represents the JSON value @"customer.source.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'source'created
  | -- | Represents the JSON value @"customer.source.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'source'deleted
  | -- | Represents the JSON value @"customer.source.expiring"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'source'expiring
  | -- | Represents the JSON value @"customer.source.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'source'updated
  | -- | Represents the JSON value @"customer.subscription.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'created
  | -- | Represents the JSON value @"customer.subscription.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'deleted
  | -- | Represents the JSON value @"customer.subscription.pending_update_applied"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'pendingUpdateApplied
  | -- | Represents the JSON value @"customer.subscription.pending_update_expired"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'pendingUpdateExpired
  | -- | Represents the JSON value @"customer.subscription.trial_will_end"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'trialWillEnd
  | -- | Represents the JSON value @"customer.subscription.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'updated
  | -- | Represents the JSON value @"customer.tax_id.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'taxId'created
  | -- | Represents the JSON value @"customer.tax_id.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'taxId'deleted
  | -- | Represents the JSON value @"customer.tax_id.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'taxId'updated
  | -- | Represents the JSON value @"customer.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'updated
  | -- | Represents the JSON value @"file.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumFile'created
  | -- | Represents the JSON value @"identity.verification_session.canceled"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'canceled
  | -- | Represents the JSON value @"identity.verification_session.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'created
  | -- | Represents the JSON value @"identity.verification_session.processing"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'processing
  | -- | Represents the JSON value @"identity.verification_session.redacted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'redacted
  | -- | Represents the JSON value @"identity.verification_session.requires_input"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'requiresInput
  | -- | Represents the JSON value @"identity.verification_session.verified"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'verified
  | -- | Represents the JSON value @"invoice.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'created
  | -- | Represents the JSON value @"invoice.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'deleted
  | -- | Represents the JSON value @"invoice.finalization_failed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'finalizationFailed
  | -- | Represents the JSON value @"invoice.finalized"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'finalized
  | -- | Represents the JSON value @"invoice.marked_uncollectible"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'markedUncollectible
  | -- | Represents the JSON value @"invoice.paid"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'paid
  | -- | Represents the JSON value @"invoice.payment_action_required"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'paymentActionRequired
  | -- | Represents the JSON value @"invoice.payment_failed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'paymentFailed
  | -- | Represents the JSON value @"invoice.payment_succeeded"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'paymentSucceeded
  | -- | Represents the JSON value @"invoice.sent"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'sent
  | -- | Represents the JSON value @"invoice.upcoming"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'upcoming
  | -- | Represents the JSON value @"invoice.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'updated
  | -- | Represents the JSON value @"invoice.voided"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'voided
  | -- | Represents the JSON value @"invoiceitem.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoiceitem'created
  | -- | Represents the JSON value @"invoiceitem.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoiceitem'deleted
  | -- | Represents the JSON value @"invoiceitem.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoiceitem'updated
  | -- | Represents the JSON value @"issuing_authorization.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingAuthorization'created
  | -- | Represents the JSON value @"issuing_authorization.request"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingAuthorization'request
  | -- | Represents the JSON value @"issuing_authorization.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingAuthorization'updated
  | -- | Represents the JSON value @"issuing_card.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingCard'created
  | -- | Represents the JSON value @"issuing_card.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingCard'updated
  | -- | Represents the JSON value @"issuing_cardholder.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingCardholder'created
  | -- | Represents the JSON value @"issuing_cardholder.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingCardholder'updated
  | -- | Represents the JSON value @"issuing_dispute.closed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'closed
  | -- | Represents the JSON value @"issuing_dispute.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'created
  | -- | Represents the JSON value @"issuing_dispute.funds_reinstated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'fundsReinstated
  | -- | Represents the JSON value @"issuing_dispute.submitted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'submitted
  | -- | Represents the JSON value @"issuing_dispute.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'updated
  | -- | Represents the JSON value @"issuing_transaction.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingTransaction'created
  | -- | Represents the JSON value @"issuing_transaction.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingTransaction'updated
  | -- | Represents the JSON value @"mandate.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumMandate'updated
  | -- | Represents the JSON value @"order.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrder'created
  | -- | Represents the JSON value @"order.payment_failed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrder'paymentFailed
  | -- | Represents the JSON value @"order.payment_succeeded"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrder'paymentSucceeded
  | -- | Represents the JSON value @"order.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrder'updated
  | -- | Represents the JSON value @"order_return.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrderReturn'created
  | -- | Represents the JSON value @"payment_intent.amount_capturable_updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'amountCapturableUpdated
  | -- | Represents the JSON value @"payment_intent.canceled"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'canceled
  | -- | Represents the JSON value @"payment_intent.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'created
  | -- | Represents the JSON value @"payment_intent.payment_failed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'paymentFailed
  | -- | Represents the JSON value @"payment_intent.processing"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'processing
  | -- | Represents the JSON value @"payment_intent.requires_action"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'requiresAction
  | -- | Represents the JSON value @"payment_intent.succeeded"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'succeeded
  | -- | Represents the JSON value @"payment_method.attached"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentMethod'attached
  | -- | Represents the JSON value @"payment_method.automatically_updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentMethod'automaticallyUpdated
  | -- | Represents the JSON value @"payment_method.detached"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentMethod'detached
  | -- | Represents the JSON value @"payment_method.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentMethod'updated
  | -- | Represents the JSON value @"payout.canceled"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'canceled
  | -- | Represents the JSON value @"payout.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'created
  | -- | Represents the JSON value @"payout.failed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'failed
  | -- | Represents the JSON value @"payout.paid"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'paid
  | -- | Represents the JSON value @"payout.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'updated
  | -- | Represents the JSON value @"person.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPerson'created
  | -- | Represents the JSON value @"person.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPerson'deleted
  | -- | Represents the JSON value @"person.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPerson'updated
  | -- | Represents the JSON value @"plan.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPlan'created
  | -- | Represents the JSON value @"plan.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPlan'deleted
  | -- | Represents the JSON value @"plan.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPlan'updated
  | -- | Represents the JSON value @"price.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPrice'created
  | -- | Represents the JSON value @"price.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPrice'deleted
  | -- | Represents the JSON value @"price.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPrice'updated
  | -- | Represents the JSON value @"product.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumProduct'created
  | -- | Represents the JSON value @"product.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumProduct'deleted
  | -- | Represents the JSON value @"product.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumProduct'updated
  | -- | Represents the JSON value @"promotion_code.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPromotionCode'created
  | -- | Represents the JSON value @"promotion_code.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPromotionCode'updated
  | -- | Represents the JSON value @"radar.early_fraud_warning.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRadar'earlyFraudWarning'created
  | -- | Represents the JSON value @"radar.early_fraud_warning.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRadar'earlyFraudWarning'updated
  | -- | Represents the JSON value @"recipient.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRecipient'created
  | -- | Represents the JSON value @"recipient.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRecipient'deleted
  | -- | Represents the JSON value @"recipient.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRecipient'updated
  | -- | Represents the JSON value @"reporting.report_run.failed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReporting'reportRun'failed
  | -- | Represents the JSON value @"reporting.report_run.succeeded"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReporting'reportRun'succeeded
  | -- | Represents the JSON value @"reporting.report_type.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReporting'reportType'updated
  | -- | Represents the JSON value @"review.closed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReview'closed
  | -- | Represents the JSON value @"review.opened"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReview'opened
  | -- | Represents the JSON value @"setup_intent.canceled"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'canceled
  | -- | Represents the JSON value @"setup_intent.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'created
  | -- | Represents the JSON value @"setup_intent.requires_action"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'requiresAction
  | -- | Represents the JSON value @"setup_intent.setup_failed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'setupFailed
  | -- | Represents the JSON value @"setup_intent.succeeded"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'succeeded
  | -- | Represents the JSON value @"sigma.scheduled_query_run.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSigma'scheduledQueryRun'created
  | -- | Represents the JSON value @"sku.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSku'created
  | -- | Represents the JSON value @"sku.deleted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSku'deleted
  | -- | Represents the JSON value @"sku.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSku'updated
  | -- | Represents the JSON value @"source.canceled"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'canceled
  | -- | Represents the JSON value @"source.chargeable"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'chargeable
  | -- | Represents the JSON value @"source.failed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'failed
  | -- | Represents the JSON value @"source.mandate_notification"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'mandateNotification
  | -- | Represents the JSON value @"source.refund_attributes_required"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'refundAttributesRequired
  | -- | Represents the JSON value @"source.transaction.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'transaction'created
  | -- | Represents the JSON value @"source.transaction.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'transaction'updated
  | -- | Represents the JSON value @"subscription_schedule.aborted"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'aborted
  | -- | Represents the JSON value @"subscription_schedule.canceled"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'canceled
  | -- | Represents the JSON value @"subscription_schedule.completed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'completed
  | -- | Represents the JSON value @"subscription_schedule.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'created
  | -- | Represents the JSON value @"subscription_schedule.expiring"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'expiring
  | -- | Represents the JSON value @"subscription_schedule.released"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'released
  | -- | Represents the JSON value @"subscription_schedule.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'updated
  | -- | Represents the JSON value @"tax_rate.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTaxRate'created
  | -- | Represents the JSON value @"tax_rate.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTaxRate'updated
  | -- | Represents the JSON value @"topup.canceled"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'canceled
  | -- | Represents the JSON value @"topup.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'created
  | -- | Represents the JSON value @"topup.failed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'failed
  | -- | Represents the JSON value @"topup.reversed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'reversed
  | -- | Represents the JSON value @"topup.succeeded"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'succeeded
  | -- | Represents the JSON value @"transfer.created"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'created
  | -- | Represents the JSON value @"transfer.failed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'failed
  | -- | Represents the JSON value @"transfer.paid"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'paid
  | -- | Represents the JSON value @"transfer.reversed"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'reversed
  | -- | Represents the JSON value @"transfer.updated"@
    PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'updated
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents' where
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'Other val) = val
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'Enum_) = "*"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'application'authorized) = "account.application.authorized"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'application'deauthorized) = "account.application.deauthorized"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'externalAccount'created) = "account.external_account.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'externalAccount'deleted) = "account.external_account.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'externalAccount'updated) = "account.external_account.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'updated) = "account.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumApplicationFee'created) = "application_fee.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumApplicationFee'refund'updated) = "application_fee.refund.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumApplicationFee'refunded) = "application_fee.refunded"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumBalance'available) = "balance.available"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumBillingPortal'configuration'created) = "billing_portal.configuration.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumBillingPortal'configuration'updated) = "billing_portal.configuration.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCapability'updated) = "capability.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'captured) = "charge.captured"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'closed) = "charge.dispute.closed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'created) = "charge.dispute.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'fundsReinstated) = "charge.dispute.funds_reinstated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'fundsWithdrawn) = "charge.dispute.funds_withdrawn"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'updated) = "charge.dispute.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'expired) = "charge.expired"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'failed) = "charge.failed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'pending) = "charge.pending"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'refund'updated) = "charge.refund.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'refunded) = "charge.refunded"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'succeeded) = "charge.succeeded"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'updated) = "charge.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCheckout'session'asyncPaymentFailed) = "checkout.session.async_payment_failed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCheckout'session'asyncPaymentSucceeded) = "checkout.session.async_payment_succeeded"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCheckout'session'completed) = "checkout.session.completed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCoupon'created) = "coupon.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCoupon'deleted) = "coupon.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCoupon'updated) = "coupon.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCreditNote'created) = "credit_note.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCreditNote'updated) = "credit_note.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCreditNote'voided) = "credit_note.voided"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'created) = "customer.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'deleted) = "customer.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'discount'created) = "customer.discount.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'discount'deleted) = "customer.discount.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'discount'updated) = "customer.discount.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'source'created) = "customer.source.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'source'deleted) = "customer.source.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'source'expiring) = "customer.source.expiring"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'source'updated) = "customer.source.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'created) = "customer.subscription.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'deleted) = "customer.subscription.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'pendingUpdateApplied) = "customer.subscription.pending_update_applied"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'pendingUpdateExpired) = "customer.subscription.pending_update_expired"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'trialWillEnd) = "customer.subscription.trial_will_end"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'updated) = "customer.subscription.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'taxId'created) = "customer.tax_id.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'taxId'deleted) = "customer.tax_id.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'taxId'updated) = "customer.tax_id.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'updated) = "customer.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumFile'created) = "file.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'canceled) = "identity.verification_session.canceled"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'created) = "identity.verification_session.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'processing) = "identity.verification_session.processing"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'redacted) = "identity.verification_session.redacted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'requiresInput) = "identity.verification_session.requires_input"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'verified) = "identity.verification_session.verified"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'created) = "invoice.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'deleted) = "invoice.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'finalizationFailed) = "invoice.finalization_failed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'finalized) = "invoice.finalized"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'markedUncollectible) = "invoice.marked_uncollectible"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'paid) = "invoice.paid"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'paymentActionRequired) = "invoice.payment_action_required"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'paymentFailed) = "invoice.payment_failed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'paymentSucceeded) = "invoice.payment_succeeded"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'sent) = "invoice.sent"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'upcoming) = "invoice.upcoming"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'updated) = "invoice.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'voided) = "invoice.voided"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoiceitem'created) = "invoiceitem.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoiceitem'deleted) = "invoiceitem.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoiceitem'updated) = "invoiceitem.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingAuthorization'created) = "issuing_authorization.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingAuthorization'request) = "issuing_authorization.request"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingAuthorization'updated) = "issuing_authorization.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingCard'created) = "issuing_card.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingCard'updated) = "issuing_card.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingCardholder'created) = "issuing_cardholder.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingCardholder'updated) = "issuing_cardholder.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'closed) = "issuing_dispute.closed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'created) = "issuing_dispute.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'fundsReinstated) = "issuing_dispute.funds_reinstated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'submitted) = "issuing_dispute.submitted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'updated) = "issuing_dispute.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingTransaction'created) = "issuing_transaction.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingTransaction'updated) = "issuing_transaction.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumMandate'updated) = "mandate.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrder'created) = "order.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrder'paymentFailed) = "order.payment_failed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrder'paymentSucceeded) = "order.payment_succeeded"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrder'updated) = "order.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrderReturn'created) = "order_return.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'amountCapturableUpdated) = "payment_intent.amount_capturable_updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'canceled) = "payment_intent.canceled"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'created) = "payment_intent.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'paymentFailed) = "payment_intent.payment_failed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'processing) = "payment_intent.processing"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'requiresAction) = "payment_intent.requires_action"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'succeeded) = "payment_intent.succeeded"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentMethod'attached) = "payment_method.attached"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentMethod'automaticallyUpdated) = "payment_method.automatically_updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentMethod'detached) = "payment_method.detached"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentMethod'updated) = "payment_method.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'canceled) = "payout.canceled"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'created) = "payout.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'failed) = "payout.failed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'paid) = "payout.paid"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'updated) = "payout.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPerson'created) = "person.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPerson'deleted) = "person.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPerson'updated) = "person.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPlan'created) = "plan.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPlan'deleted) = "plan.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPlan'updated) = "plan.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPrice'created) = "price.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPrice'deleted) = "price.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPrice'updated) = "price.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumProduct'created) = "product.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumProduct'deleted) = "product.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumProduct'updated) = "product.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPromotionCode'created) = "promotion_code.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPromotionCode'updated) = "promotion_code.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRadar'earlyFraudWarning'created) = "radar.early_fraud_warning.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRadar'earlyFraudWarning'updated) = "radar.early_fraud_warning.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRecipient'created) = "recipient.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRecipient'deleted) = "recipient.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRecipient'updated) = "recipient.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReporting'reportRun'failed) = "reporting.report_run.failed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReporting'reportRun'succeeded) = "reporting.report_run.succeeded"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReporting'reportType'updated) = "reporting.report_type.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReview'closed) = "review.closed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReview'opened) = "review.opened"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'canceled) = "setup_intent.canceled"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'created) = "setup_intent.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'requiresAction) = "setup_intent.requires_action"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'setupFailed) = "setup_intent.setup_failed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'succeeded) = "setup_intent.succeeded"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSigma'scheduledQueryRun'created) = "sigma.scheduled_query_run.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSku'created) = "sku.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSku'deleted) = "sku.deleted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSku'updated) = "sku.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'canceled) = "source.canceled"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'chargeable) = "source.chargeable"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'failed) = "source.failed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'mandateNotification) = "source.mandate_notification"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'refundAttributesRequired) = "source.refund_attributes_required"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'transaction'created) = "source.transaction.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'transaction'updated) = "source.transaction.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'aborted) = "subscription_schedule.aborted"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'canceled) = "subscription_schedule.canceled"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'completed) = "subscription_schedule.completed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'created) = "subscription_schedule.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'expiring) = "subscription_schedule.expiring"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'released) = "subscription_schedule.released"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'updated) = "subscription_schedule.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTaxRate'created) = "tax_rate.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTaxRate'updated) = "tax_rate.updated"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'canceled) = "topup.canceled"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'created) = "topup.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'failed) = "topup.failed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'reversed) = "topup.reversed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'succeeded) = "topup.succeeded"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'created) = "transfer.created"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'failed) = "transfer.failed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'paid) = "transfer.paid"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'reversed) = "transfer.reversed"
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'updated) = "transfer.updated"

instance Data.Aeson.Types.FromJSON.FromJSON PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "*" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'Enum_
            | val GHC.Classes.== "account.application.authorized" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'application'authorized
            | val GHC.Classes.== "account.application.deauthorized" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'application'deauthorized
            | val GHC.Classes.== "account.external_account.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'externalAccount'created
            | val GHC.Classes.== "account.external_account.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'externalAccount'deleted
            | val GHC.Classes.== "account.external_account.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'externalAccount'updated
            | val GHC.Classes.== "account.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumAccount'updated
            | val GHC.Classes.== "application_fee.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumApplicationFee'created
            | val GHC.Classes.== "application_fee.refund.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumApplicationFee'refund'updated
            | val GHC.Classes.== "application_fee.refunded" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumApplicationFee'refunded
            | val GHC.Classes.== "balance.available" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumBalance'available
            | val GHC.Classes.== "billing_portal.configuration.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumBillingPortal'configuration'created
            | val GHC.Classes.== "billing_portal.configuration.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumBillingPortal'configuration'updated
            | val GHC.Classes.== "capability.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCapability'updated
            | val GHC.Classes.== "charge.captured" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'captured
            | val GHC.Classes.== "charge.dispute.closed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'closed
            | val GHC.Classes.== "charge.dispute.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'created
            | val GHC.Classes.== "charge.dispute.funds_reinstated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'fundsReinstated
            | val GHC.Classes.== "charge.dispute.funds_withdrawn" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'fundsWithdrawn
            | val GHC.Classes.== "charge.dispute.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'dispute'updated
            | val GHC.Classes.== "charge.expired" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'expired
            | val GHC.Classes.== "charge.failed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'failed
            | val GHC.Classes.== "charge.pending" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'pending
            | val GHC.Classes.== "charge.refund.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'refund'updated
            | val GHC.Classes.== "charge.refunded" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'refunded
            | val GHC.Classes.== "charge.succeeded" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'succeeded
            | val GHC.Classes.== "charge.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCharge'updated
            | val GHC.Classes.== "checkout.session.async_payment_failed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCheckout'session'asyncPaymentFailed
            | val GHC.Classes.== "checkout.session.async_payment_succeeded" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCheckout'session'asyncPaymentSucceeded
            | val GHC.Classes.== "checkout.session.completed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCheckout'session'completed
            | val GHC.Classes.== "coupon.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCoupon'created
            | val GHC.Classes.== "coupon.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCoupon'deleted
            | val GHC.Classes.== "coupon.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCoupon'updated
            | val GHC.Classes.== "credit_note.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCreditNote'created
            | val GHC.Classes.== "credit_note.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCreditNote'updated
            | val GHC.Classes.== "credit_note.voided" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCreditNote'voided
            | val GHC.Classes.== "customer.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'created
            | val GHC.Classes.== "customer.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'deleted
            | val GHC.Classes.== "customer.discount.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'discount'created
            | val GHC.Classes.== "customer.discount.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'discount'deleted
            | val GHC.Classes.== "customer.discount.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'discount'updated
            | val GHC.Classes.== "customer.source.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'source'created
            | val GHC.Classes.== "customer.source.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'source'deleted
            | val GHC.Classes.== "customer.source.expiring" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'source'expiring
            | val GHC.Classes.== "customer.source.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'source'updated
            | val GHC.Classes.== "customer.subscription.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'created
            | val GHC.Classes.== "customer.subscription.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'deleted
            | val GHC.Classes.== "customer.subscription.pending_update_applied" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'pendingUpdateApplied
            | val GHC.Classes.== "customer.subscription.pending_update_expired" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'pendingUpdateExpired
            | val GHC.Classes.== "customer.subscription.trial_will_end" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'trialWillEnd
            | val GHC.Classes.== "customer.subscription.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'subscription'updated
            | val GHC.Classes.== "customer.tax_id.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'taxId'created
            | val GHC.Classes.== "customer.tax_id.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'taxId'deleted
            | val GHC.Classes.== "customer.tax_id.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'taxId'updated
            | val GHC.Classes.== "customer.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumCustomer'updated
            | val GHC.Classes.== "file.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumFile'created
            | val GHC.Classes.== "identity.verification_session.canceled" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'canceled
            | val GHC.Classes.== "identity.verification_session.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'created
            | val GHC.Classes.== "identity.verification_session.processing" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'processing
            | val GHC.Classes.== "identity.verification_session.redacted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'redacted
            | val GHC.Classes.== "identity.verification_session.requires_input" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'requiresInput
            | val GHC.Classes.== "identity.verification_session.verified" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIdentity'verificationSession'verified
            | val GHC.Classes.== "invoice.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'created
            | val GHC.Classes.== "invoice.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'deleted
            | val GHC.Classes.== "invoice.finalization_failed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'finalizationFailed
            | val GHC.Classes.== "invoice.finalized" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'finalized
            | val GHC.Classes.== "invoice.marked_uncollectible" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'markedUncollectible
            | val GHC.Classes.== "invoice.paid" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'paid
            | val GHC.Classes.== "invoice.payment_action_required" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'paymentActionRequired
            | val GHC.Classes.== "invoice.payment_failed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'paymentFailed
            | val GHC.Classes.== "invoice.payment_succeeded" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'paymentSucceeded
            | val GHC.Classes.== "invoice.sent" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'sent
            | val GHC.Classes.== "invoice.upcoming" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'upcoming
            | val GHC.Classes.== "invoice.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'updated
            | val GHC.Classes.== "invoice.voided" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoice'voided
            | val GHC.Classes.== "invoiceitem.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoiceitem'created
            | val GHC.Classes.== "invoiceitem.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoiceitem'deleted
            | val GHC.Classes.== "invoiceitem.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumInvoiceitem'updated
            | val GHC.Classes.== "issuing_authorization.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingAuthorization'created
            | val GHC.Classes.== "issuing_authorization.request" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingAuthorization'request
            | val GHC.Classes.== "issuing_authorization.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingAuthorization'updated
            | val GHC.Classes.== "issuing_card.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingCard'created
            | val GHC.Classes.== "issuing_card.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingCard'updated
            | val GHC.Classes.== "issuing_cardholder.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingCardholder'created
            | val GHC.Classes.== "issuing_cardholder.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingCardholder'updated
            | val GHC.Classes.== "issuing_dispute.closed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'closed
            | val GHC.Classes.== "issuing_dispute.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'created
            | val GHC.Classes.== "issuing_dispute.funds_reinstated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'fundsReinstated
            | val GHC.Classes.== "issuing_dispute.submitted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'submitted
            | val GHC.Classes.== "issuing_dispute.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingDispute'updated
            | val GHC.Classes.== "issuing_transaction.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingTransaction'created
            | val GHC.Classes.== "issuing_transaction.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumIssuingTransaction'updated
            | val GHC.Classes.== "mandate.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumMandate'updated
            | val GHC.Classes.== "order.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrder'created
            | val GHC.Classes.== "order.payment_failed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrder'paymentFailed
            | val GHC.Classes.== "order.payment_succeeded" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrder'paymentSucceeded
            | val GHC.Classes.== "order.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrder'updated
            | val GHC.Classes.== "order_return.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumOrderReturn'created
            | val GHC.Classes.== "payment_intent.amount_capturable_updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'amountCapturableUpdated
            | val GHC.Classes.== "payment_intent.canceled" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'canceled
            | val GHC.Classes.== "payment_intent.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'created
            | val GHC.Classes.== "payment_intent.payment_failed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'paymentFailed
            | val GHC.Classes.== "payment_intent.processing" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'processing
            | val GHC.Classes.== "payment_intent.requires_action" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'requiresAction
            | val GHC.Classes.== "payment_intent.succeeded" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentIntent'succeeded
            | val GHC.Classes.== "payment_method.attached" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentMethod'attached
            | val GHC.Classes.== "payment_method.automatically_updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentMethod'automaticallyUpdated
            | val GHC.Classes.== "payment_method.detached" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentMethod'detached
            | val GHC.Classes.== "payment_method.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPaymentMethod'updated
            | val GHC.Classes.== "payout.canceled" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'canceled
            | val GHC.Classes.== "payout.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'created
            | val GHC.Classes.== "payout.failed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'failed
            | val GHC.Classes.== "payout.paid" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'paid
            | val GHC.Classes.== "payout.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPayout'updated
            | val GHC.Classes.== "person.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPerson'created
            | val GHC.Classes.== "person.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPerson'deleted
            | val GHC.Classes.== "person.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPerson'updated
            | val GHC.Classes.== "plan.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPlan'created
            | val GHC.Classes.== "plan.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPlan'deleted
            | val GHC.Classes.== "plan.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPlan'updated
            | val GHC.Classes.== "price.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPrice'created
            | val GHC.Classes.== "price.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPrice'deleted
            | val GHC.Classes.== "price.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPrice'updated
            | val GHC.Classes.== "product.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumProduct'created
            | val GHC.Classes.== "product.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumProduct'deleted
            | val GHC.Classes.== "product.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumProduct'updated
            | val GHC.Classes.== "promotion_code.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPromotionCode'created
            | val GHC.Classes.== "promotion_code.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumPromotionCode'updated
            | val GHC.Classes.== "radar.early_fraud_warning.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRadar'earlyFraudWarning'created
            | val GHC.Classes.== "radar.early_fraud_warning.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRadar'earlyFraudWarning'updated
            | val GHC.Classes.== "recipient.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRecipient'created
            | val GHC.Classes.== "recipient.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRecipient'deleted
            | val GHC.Classes.== "recipient.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumRecipient'updated
            | val GHC.Classes.== "reporting.report_run.failed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReporting'reportRun'failed
            | val GHC.Classes.== "reporting.report_run.succeeded" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReporting'reportRun'succeeded
            | val GHC.Classes.== "reporting.report_type.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReporting'reportType'updated
            | val GHC.Classes.== "review.closed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReview'closed
            | val GHC.Classes.== "review.opened" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumReview'opened
            | val GHC.Classes.== "setup_intent.canceled" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'canceled
            | val GHC.Classes.== "setup_intent.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'created
            | val GHC.Classes.== "setup_intent.requires_action" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'requiresAction
            | val GHC.Classes.== "setup_intent.setup_failed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'setupFailed
            | val GHC.Classes.== "setup_intent.succeeded" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSetupIntent'succeeded
            | val GHC.Classes.== "sigma.scheduled_query_run.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSigma'scheduledQueryRun'created
            | val GHC.Classes.== "sku.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSku'created
            | val GHC.Classes.== "sku.deleted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSku'deleted
            | val GHC.Classes.== "sku.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSku'updated
            | val GHC.Classes.== "source.canceled" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'canceled
            | val GHC.Classes.== "source.chargeable" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'chargeable
            | val GHC.Classes.== "source.failed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'failed
            | val GHC.Classes.== "source.mandate_notification" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'mandateNotification
            | val GHC.Classes.== "source.refund_attributes_required" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'refundAttributesRequired
            | val GHC.Classes.== "source.transaction.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'transaction'created
            | val GHC.Classes.== "source.transaction.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSource'transaction'updated
            | val GHC.Classes.== "subscription_schedule.aborted" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'aborted
            | val GHC.Classes.== "subscription_schedule.canceled" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'canceled
            | val GHC.Classes.== "subscription_schedule.completed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'completed
            | val GHC.Classes.== "subscription_schedule.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'created
            | val GHC.Classes.== "subscription_schedule.expiring" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'expiring
            | val GHC.Classes.== "subscription_schedule.released" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'released
            | val GHC.Classes.== "subscription_schedule.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumSubscriptionSchedule'updated
            | val GHC.Classes.== "tax_rate.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTaxRate'created
            | val GHC.Classes.== "tax_rate.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTaxRate'updated
            | val GHC.Classes.== "topup.canceled" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'canceled
            | val GHC.Classes.== "topup.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'created
            | val GHC.Classes.== "topup.failed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'failed
            | val GHC.Classes.== "topup.reversed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'reversed
            | val GHC.Classes.== "topup.succeeded" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTopup'succeeded
            | val GHC.Classes.== "transfer.created" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'created
            | val GHC.Classes.== "transfer.failed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'failed
            | val GHC.Classes.== "transfer.paid" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'paid
            | val GHC.Classes.== "transfer.reversed" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'reversed
            | val GHC.Classes.== "transfer.updated" -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'EnumTransfer'updated
            | GHC.Base.otherwise -> PostWebhookEndpointsWebhookEndpointRequestBodyEnabledEvents'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/webhook_endpoints\/{webhook_endpoint}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.metadata.anyOf@ in the specification.
--
-- Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
data PostWebhookEndpointsWebhookEndpointRequestBodyMetadata'Variants
  = -- | Represents the JSON value @""@
    PostWebhookEndpointsWebhookEndpointRequestBodyMetadata'EmptyString
  | PostWebhookEndpointsWebhookEndpointRequestBodyMetadata'Object Data.Aeson.Types.Internal.Object
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostWebhookEndpointsWebhookEndpointRequestBodyMetadata'Variants where
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyMetadata'Object a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostWebhookEndpointsWebhookEndpointRequestBodyMetadata'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostWebhookEndpointsWebhookEndpointRequestBodyMetadata'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostWebhookEndpointsWebhookEndpointRequestBodyMetadata'EmptyString
        | GHC.Base.otherwise -> case (PostWebhookEndpointsWebhookEndpointRequestBodyMetadata'Object Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Represents a response of the operation 'postWebhookEndpointsWebhookEndpoint'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostWebhookEndpointsWebhookEndpointResponseError' is used.
data PostWebhookEndpointsWebhookEndpointResponse
  = -- | Means either no matching case available or a parse error
    PostWebhookEndpointsWebhookEndpointResponseError GHC.Base.String
  | -- | Successful response.
    PostWebhookEndpointsWebhookEndpointResponse200 WebhookEndpoint
  | -- | Error response.
    PostWebhookEndpointsWebhookEndpointResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
