{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema BillingPortal_Session
module StripeAPI.Types.BillingPortal_Session where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.BillingPortal_Configuration
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.billing_portal.session@ in the specification.
--
-- The Billing customer portal is a Stripe-hosted UI for subscription and
-- billing management.
--
-- A portal configuration describes the functionality and features that you
-- want to provide to your customers through the portal.
--
-- A portal session describes the instantiation of the customer portal for
-- a particular customer. By visiting the session\'s URL, the customer
-- can manage their subscriptions and billing details. For security reasons,
-- sessions are short-lived and will expire if the customer does not visit the URL.
-- Create sessions on-demand when customers intend to manage their subscriptions
-- and billing details.
--
-- Learn more in the [product overview](https:\/\/stripe.com\/docs\/billing\/subscriptions\/customer-portal)
-- and [integration guide](https:\/\/stripe.com\/docs\/billing\/subscriptions\/integrating-customer-portal).
data BillingPortal'session = BillingPortal'session
  { -- | configuration: The configuration used by this session, describing the features available.
    billingPortal'sessionConfiguration :: BillingPortal'sessionConfiguration'Variants,
    -- | created: Time at which the object was created. Measured in seconds since the Unix epoch.
    billingPortal'sessionCreated :: GHC.Types.Int,
    -- | customer: The ID of the customer for this session.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    billingPortal'sessionCustomer :: Data.Text.Internal.Text,
    -- | id: Unique identifier for the object.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    billingPortal'sessionId :: Data.Text.Internal.Text,
    -- | livemode: Has the value \`true\` if the object exists in live mode or the value \`false\` if the object exists in test mode.
    billingPortal'sessionLivemode :: GHC.Types.Bool,
    -- | on_behalf_of: The account for which the session was created on behalf of. When specified, only subscriptions and invoices with this \`on_behalf_of\` account appear in the portal. For more information, see the [docs](https:\/\/stripe.com\/docs\/connect\/charges-transfers\#on-behalf-of). Use the [Accounts API](https:\/\/stripe.com\/docs\/api\/accounts\/object\#account_object-settings-branding) to modify the \`on_behalf_of\` account\'s branding settings, which the portal displays.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    billingPortal'sessionOnBehalfOf :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | return_url: The URL to redirect customers to when they click on the portal\'s link to return to your website.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    billingPortal'sessionReturnUrl :: Data.Text.Internal.Text,
    -- | url: The short-lived URL of the session that gives customers access to the customer portal.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    billingPortal'sessionUrl :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON BillingPortal'session where
  toJSON obj = Data.Aeson.Types.Internal.object ("configuration" Data.Aeson.Types.ToJSON..= billingPortal'sessionConfiguration obj : "created" Data.Aeson.Types.ToJSON..= billingPortal'sessionCreated obj : "customer" Data.Aeson.Types.ToJSON..= billingPortal'sessionCustomer obj : "id" Data.Aeson.Types.ToJSON..= billingPortal'sessionId obj : "livemode" Data.Aeson.Types.ToJSON..= billingPortal'sessionLivemode obj : "on_behalf_of" Data.Aeson.Types.ToJSON..= billingPortal'sessionOnBehalfOf obj : "return_url" Data.Aeson.Types.ToJSON..= billingPortal'sessionReturnUrl obj : "url" Data.Aeson.Types.ToJSON..= billingPortal'sessionUrl obj : "object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "billing_portal.session" : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("configuration" Data.Aeson.Types.ToJSON..= billingPortal'sessionConfiguration obj) GHC.Base.<> (("created" Data.Aeson.Types.ToJSON..= billingPortal'sessionCreated obj) GHC.Base.<> (("customer" Data.Aeson.Types.ToJSON..= billingPortal'sessionCustomer obj) GHC.Base.<> (("id" Data.Aeson.Types.ToJSON..= billingPortal'sessionId obj) GHC.Base.<> (("livemode" Data.Aeson.Types.ToJSON..= billingPortal'sessionLivemode obj) GHC.Base.<> (("on_behalf_of" Data.Aeson.Types.ToJSON..= billingPortal'sessionOnBehalfOf obj) GHC.Base.<> (("return_url" Data.Aeson.Types.ToJSON..= billingPortal'sessionReturnUrl obj) GHC.Base.<> (("url" Data.Aeson.Types.ToJSON..= billingPortal'sessionUrl obj) GHC.Base.<> ("object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "billing_portal.session")))))))))

instance Data.Aeson.Types.FromJSON.FromJSON BillingPortal'session where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "BillingPortal'session" (\obj -> (((((((GHC.Base.pure BillingPortal'session GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "configuration")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "created")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "customer")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "livemode")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "on_behalf_of")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "return_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "url"))

-- | Create a new 'BillingPortal'session' with all required fields.
mkBillingPortal'session ::
  -- | 'billingPortal'sessionConfiguration'
  BillingPortal'sessionConfiguration'Variants ->
  -- | 'billingPortal'sessionCreated'
  GHC.Types.Int ->
  -- | 'billingPortal'sessionCustomer'
  Data.Text.Internal.Text ->
  -- | 'billingPortal'sessionId'
  Data.Text.Internal.Text ->
  -- | 'billingPortal'sessionLivemode'
  GHC.Types.Bool ->
  -- | 'billingPortal'sessionReturnUrl'
  Data.Text.Internal.Text ->
  -- | 'billingPortal'sessionUrl'
  Data.Text.Internal.Text ->
  BillingPortal'session
mkBillingPortal'session billingPortal'sessionConfiguration billingPortal'sessionCreated billingPortal'sessionCustomer billingPortal'sessionId billingPortal'sessionLivemode billingPortal'sessionReturnUrl billingPortal'sessionUrl =
  BillingPortal'session
    { billingPortal'sessionConfiguration = billingPortal'sessionConfiguration,
      billingPortal'sessionCreated = billingPortal'sessionCreated,
      billingPortal'sessionCustomer = billingPortal'sessionCustomer,
      billingPortal'sessionId = billingPortal'sessionId,
      billingPortal'sessionLivemode = billingPortal'sessionLivemode,
      billingPortal'sessionOnBehalfOf = GHC.Maybe.Nothing,
      billingPortal'sessionReturnUrl = billingPortal'sessionReturnUrl,
      billingPortal'sessionUrl = billingPortal'sessionUrl
    }

-- | Defines the oneOf schema located at @components.schemas.billing_portal.session.properties.configuration.anyOf@ in the specification.
--
-- The configuration used by this session, describing the features available.
data BillingPortal'sessionConfiguration'Variants
  = BillingPortal'sessionConfiguration'Text Data.Text.Internal.Text
  | BillingPortal'sessionConfiguration'BillingPortal'configuration BillingPortal'configuration
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON BillingPortal'sessionConfiguration'Variants where
  toJSON (BillingPortal'sessionConfiguration'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (BillingPortal'sessionConfiguration'BillingPortal'configuration a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON BillingPortal'sessionConfiguration'Variants where
  parseJSON val = case (BillingPortal'sessionConfiguration'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((BillingPortal'sessionConfiguration'BillingPortal'configuration Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a
