{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema ConnectCollectionTransfer
module StripeAPI.Types.ConnectCollectionTransfer where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.Account
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.connect_collection_transfer@ in the specification.
data ConnectCollectionTransfer = ConnectCollectionTransfer
  { -- | amount: Amount transferred, in %s.
    connectCollectionTransferAmount :: GHC.Types.Int,
    -- | currency: Three-letter [ISO currency code](https:\/\/www.iso.org\/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https:\/\/stripe.com\/docs\/currencies).
    connectCollectionTransferCurrency :: Data.Text.Internal.Text,
    -- | destination: ID of the account that funds are being collected for.
    connectCollectionTransferDestination :: ConnectCollectionTransferDestination'Variants,
    -- | id: Unique identifier for the object.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    connectCollectionTransferId :: Data.Text.Internal.Text,
    -- | livemode: Has the value \`true\` if the object exists in live mode or the value \`false\` if the object exists in test mode.
    connectCollectionTransferLivemode :: GHC.Types.Bool
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON ConnectCollectionTransfer where
  toJSON obj = Data.Aeson.Types.Internal.object ("amount" Data.Aeson.Types.ToJSON..= connectCollectionTransferAmount obj : "currency" Data.Aeson.Types.ToJSON..= connectCollectionTransferCurrency obj : "destination" Data.Aeson.Types.ToJSON..= connectCollectionTransferDestination obj : "id" Data.Aeson.Types.ToJSON..= connectCollectionTransferId obj : "livemode" Data.Aeson.Types.ToJSON..= connectCollectionTransferLivemode obj : "object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "connect_collection_transfer" : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("amount" Data.Aeson.Types.ToJSON..= connectCollectionTransferAmount obj) GHC.Base.<> (("currency" Data.Aeson.Types.ToJSON..= connectCollectionTransferCurrency obj) GHC.Base.<> (("destination" Data.Aeson.Types.ToJSON..= connectCollectionTransferDestination obj) GHC.Base.<> (("id" Data.Aeson.Types.ToJSON..= connectCollectionTransferId obj) GHC.Base.<> (("livemode" Data.Aeson.Types.ToJSON..= connectCollectionTransferLivemode obj) GHC.Base.<> ("object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "connect_collection_transfer"))))))

instance Data.Aeson.Types.FromJSON.FromJSON ConnectCollectionTransfer where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "ConnectCollectionTransfer" (\obj -> ((((GHC.Base.pure ConnectCollectionTransfer GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "destination")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "livemode"))

-- | Create a new 'ConnectCollectionTransfer' with all required fields.
mkConnectCollectionTransfer ::
  -- | 'connectCollectionTransferAmount'
  GHC.Types.Int ->
  -- | 'connectCollectionTransferCurrency'
  Data.Text.Internal.Text ->
  -- | 'connectCollectionTransferDestination'
  ConnectCollectionTransferDestination'Variants ->
  -- | 'connectCollectionTransferId'
  Data.Text.Internal.Text ->
  -- | 'connectCollectionTransferLivemode'
  GHC.Types.Bool ->
  ConnectCollectionTransfer
mkConnectCollectionTransfer connectCollectionTransferAmount connectCollectionTransferCurrency connectCollectionTransferDestination connectCollectionTransferId connectCollectionTransferLivemode =
  ConnectCollectionTransfer
    { connectCollectionTransferAmount = connectCollectionTransferAmount,
      connectCollectionTransferCurrency = connectCollectionTransferCurrency,
      connectCollectionTransferDestination = connectCollectionTransferDestination,
      connectCollectionTransferId = connectCollectionTransferId,
      connectCollectionTransferLivemode = connectCollectionTransferLivemode
    }

-- | Defines the oneOf schema located at @components.schemas.connect_collection_transfer.properties.destination.anyOf@ in the specification.
--
-- ID of the account that funds are being collected for.
data ConnectCollectionTransferDestination'Variants
  = ConnectCollectionTransferDestination'Text Data.Text.Internal.Text
  | ConnectCollectionTransferDestination'Account Account
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON ConnectCollectionTransferDestination'Variants where
  toJSON (ConnectCollectionTransferDestination'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (ConnectCollectionTransferDestination'Account a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON ConnectCollectionTransferDestination'Variants where
  parseJSON val = case (ConnectCollectionTransferDestination'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((ConnectCollectionTransferDestination'Account Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a
