{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema IssuingCardholderIndividual
module StripeAPI.Types.IssuingCardholderIndividual where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.File
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderIdDocument
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderIndividualDob
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderVerification
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.issuing_cardholder_individual@ in the specification.
data IssuingCardholderIndividual = IssuingCardholderIndividual
  { -- | dob: The date of birth of this cardholder.
    issuingCardholderIndividualDob :: (GHC.Maybe.Maybe IssuingCardholderIndividualDob'),
    -- | first_name: The first name of this cardholder.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuingCardholderIndividualFirstName :: Data.Text.Internal.Text,
    -- | last_name: The last name of this cardholder.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuingCardholderIndividualLastName :: Data.Text.Internal.Text,
    -- | verification: Government-issued ID document for this cardholder.
    issuingCardholderIndividualVerification :: (GHC.Maybe.Maybe IssuingCardholderIndividualVerification')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardholderIndividual where
  toJSON obj = Data.Aeson.Types.Internal.object ("dob" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualDob obj : "first_name" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualFirstName obj : "last_name" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualLastName obj : "verification" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualVerification obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("dob" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualDob obj) GHC.Base.<> (("first_name" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualFirstName obj) GHC.Base.<> (("last_name" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualLastName obj) GHC.Base.<> ("verification" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualVerification obj))))

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardholderIndividual where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "IssuingCardholderIndividual" (\obj -> (((GHC.Base.pure IssuingCardholderIndividual GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "dob")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "first_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "last_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "verification"))

-- | Create a new 'IssuingCardholderIndividual' with all required fields.
mkIssuingCardholderIndividual ::
  -- | 'issuingCardholderIndividualFirstName'
  Data.Text.Internal.Text ->
  -- | 'issuingCardholderIndividualLastName'
  Data.Text.Internal.Text ->
  IssuingCardholderIndividual
mkIssuingCardholderIndividual issuingCardholderIndividualFirstName issuingCardholderIndividualLastName =
  IssuingCardholderIndividual
    { issuingCardholderIndividualDob = GHC.Maybe.Nothing,
      issuingCardholderIndividualFirstName = issuingCardholderIndividualFirstName,
      issuingCardholderIndividualLastName = issuingCardholderIndividualLastName,
      issuingCardholderIndividualVerification = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @components.schemas.issuing_cardholder_individual.properties.dob.anyOf@ in the specification.
--
-- The date of birth of this cardholder.
data IssuingCardholderIndividualDob' = IssuingCardholderIndividualDob'
  { -- | day: The day of birth, between 1 and 31.
    issuingCardholderIndividualDob'Day :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | month: The month of birth, between 1 and 12.
    issuingCardholderIndividualDob'Month :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | year: The four-digit year of birth.
    issuingCardholderIndividualDob'Year :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardholderIndividualDob' where
  toJSON obj = Data.Aeson.Types.Internal.object ("day" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualDob'Day obj : "month" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualDob'Month obj : "year" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualDob'Year obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("day" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualDob'Day obj) GHC.Base.<> (("month" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualDob'Month obj) GHC.Base.<> ("year" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualDob'Year obj)))

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardholderIndividualDob' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "IssuingCardholderIndividualDob'" (\obj -> ((GHC.Base.pure IssuingCardholderIndividualDob' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "day")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "month")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "year"))

-- | Create a new 'IssuingCardholderIndividualDob'' with all required fields.
mkIssuingCardholderIndividualDob' :: IssuingCardholderIndividualDob'
mkIssuingCardholderIndividualDob' =
  IssuingCardholderIndividualDob'
    { issuingCardholderIndividualDob'Day = GHC.Maybe.Nothing,
      issuingCardholderIndividualDob'Month = GHC.Maybe.Nothing,
      issuingCardholderIndividualDob'Year = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @components.schemas.issuing_cardholder_individual.properties.verification.anyOf@ in the specification.
--
-- Government-issued ID document for this cardholder.
data IssuingCardholderIndividualVerification' = IssuingCardholderIndividualVerification'
  { -- | document: An identifying document, either a passport or local ID card.
    issuingCardholderIndividualVerification'Document :: (GHC.Maybe.Maybe IssuingCardholderIndividualVerification'Document')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardholderIndividualVerification' where
  toJSON obj = Data.Aeson.Types.Internal.object ("document" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualVerification'Document obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("document" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualVerification'Document obj)

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardholderIndividualVerification' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "IssuingCardholderIndividualVerification'" (\obj -> GHC.Base.pure IssuingCardholderIndividualVerification' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "document"))

-- | Create a new 'IssuingCardholderIndividualVerification'' with all required fields.
mkIssuingCardholderIndividualVerification' :: IssuingCardholderIndividualVerification'
mkIssuingCardholderIndividualVerification' = IssuingCardholderIndividualVerification' {issuingCardholderIndividualVerification'Document = GHC.Maybe.Nothing}

-- | Defines the object schema located at @components.schemas.issuing_cardholder_individual.properties.verification.anyOf.properties.document.anyOf@ in the specification.
--
-- An identifying document, either a passport or local ID card.
data IssuingCardholderIndividualVerification'Document' = IssuingCardholderIndividualVerification'Document'
  { -- | back: The back of a document returned by a [file upload](https:\/\/stripe.com\/docs\/api\#create_file) with a \`purpose\` value of \`identity_document\`.
    issuingCardholderIndividualVerification'Document'Back :: (GHC.Maybe.Maybe IssuingCardholderIndividualVerification'Document'Back'Variants),
    -- | front: The front of a document returned by a [file upload](https:\/\/stripe.com\/docs\/api\#create_file) with a \`purpose\` value of \`identity_document\`.
    issuingCardholderIndividualVerification'Document'Front :: (GHC.Maybe.Maybe IssuingCardholderIndividualVerification'Document'Front'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardholderIndividualVerification'Document' where
  toJSON obj = Data.Aeson.Types.Internal.object ("back" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualVerification'Document'Back obj : "front" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualVerification'Document'Front obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("back" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualVerification'Document'Back obj) GHC.Base.<> ("front" Data.Aeson.Types.ToJSON..= issuingCardholderIndividualVerification'Document'Front obj))

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardholderIndividualVerification'Document' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "IssuingCardholderIndividualVerification'Document'" (\obj -> (GHC.Base.pure IssuingCardholderIndividualVerification'Document' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "back")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "front"))

-- | Create a new 'IssuingCardholderIndividualVerification'Document'' with all required fields.
mkIssuingCardholderIndividualVerification'Document' :: IssuingCardholderIndividualVerification'Document'
mkIssuingCardholderIndividualVerification'Document' =
  IssuingCardholderIndividualVerification'Document'
    { issuingCardholderIndividualVerification'Document'Back = GHC.Maybe.Nothing,
      issuingCardholderIndividualVerification'Document'Front = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @components.schemas.issuing_cardholder_individual.properties.verification.anyOf.properties.document.anyOf.properties.back.anyOf@ in the specification.
--
-- The back of a document returned by a [file upload](https:\/\/stripe.com\/docs\/api\#create_file) with a \`purpose\` value of \`identity_document\`.
data IssuingCardholderIndividualVerification'Document'Back'Variants
  = IssuingCardholderIndividualVerification'Document'Back'Text Data.Text.Internal.Text
  | IssuingCardholderIndividualVerification'Document'Back'File File
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardholderIndividualVerification'Document'Back'Variants where
  toJSON (IssuingCardholderIndividualVerification'Document'Back'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (IssuingCardholderIndividualVerification'Document'Back'File a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardholderIndividualVerification'Document'Back'Variants where
  parseJSON val = case (IssuingCardholderIndividualVerification'Document'Back'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((IssuingCardholderIndividualVerification'Document'Back'File Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the oneOf schema located at @components.schemas.issuing_cardholder_individual.properties.verification.anyOf.properties.document.anyOf.properties.front.anyOf@ in the specification.
--
-- The front of a document returned by a [file upload](https:\/\/stripe.com\/docs\/api\#create_file) with a \`purpose\` value of \`identity_document\`.
data IssuingCardholderIndividualVerification'Document'Front'Variants
  = IssuingCardholderIndividualVerification'Document'Front'Text Data.Text.Internal.Text
  | IssuingCardholderIndividualVerification'Document'Front'File File
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardholderIndividualVerification'Document'Front'Variants where
  toJSON (IssuingCardholderIndividualVerification'Document'Front'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (IssuingCardholderIndividualVerification'Document'Front'File a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardholderIndividualVerification'Document'Front'Variants where
  parseJSON val = case (IssuingCardholderIndividualVerification'Document'Front'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((IssuingCardholderIndividualVerification'Document'Front'File Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a
