{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentIntentNextActionBoleto
module StripeAPI.Types.PaymentIntentNextActionBoleto where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_intent_next_action_boleto@ in the specification.
data PaymentIntentNextActionBoleto = PaymentIntentNextActionBoleto
  { -- | expires_at: The timestamp after which the boleto expires.
    paymentIntentNextActionBoletoExpiresAt :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | hosted_voucher_url: The URL to the hosted boleto voucher page, which allows customers to view the boleto voucher.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentIntentNextActionBoletoHostedVoucherUrl :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | number: The boleto number.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentIntentNextActionBoletoNumber :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | pdf: The URL to the downloadable boleto voucher PDF.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentIntentNextActionBoletoPdf :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentIntentNextActionBoleto where
  toJSON obj = Data.Aeson.Types.Internal.object ("expires_at" Data.Aeson.Types.ToJSON..= paymentIntentNextActionBoletoExpiresAt obj : "hosted_voucher_url" Data.Aeson.Types.ToJSON..= paymentIntentNextActionBoletoHostedVoucherUrl obj : "number" Data.Aeson.Types.ToJSON..= paymentIntentNextActionBoletoNumber obj : "pdf" Data.Aeson.Types.ToJSON..= paymentIntentNextActionBoletoPdf obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("expires_at" Data.Aeson.Types.ToJSON..= paymentIntentNextActionBoletoExpiresAt obj) GHC.Base.<> (("hosted_voucher_url" Data.Aeson.Types.ToJSON..= paymentIntentNextActionBoletoHostedVoucherUrl obj) GHC.Base.<> (("number" Data.Aeson.Types.ToJSON..= paymentIntentNextActionBoletoNumber obj) GHC.Base.<> ("pdf" Data.Aeson.Types.ToJSON..= paymentIntentNextActionBoletoPdf obj))))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentIntentNextActionBoleto where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentIntentNextActionBoleto" (\obj -> (((GHC.Base.pure PaymentIntentNextActionBoleto GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "expires_at")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "hosted_voucher_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "number")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "pdf"))

-- | Create a new 'PaymentIntentNextActionBoleto' with all required fields.
mkPaymentIntentNextActionBoleto :: PaymentIntentNextActionBoleto
mkPaymentIntentNextActionBoleto =
  PaymentIntentNextActionBoleto
    { paymentIntentNextActionBoletoExpiresAt = GHC.Maybe.Nothing,
      paymentIntentNextActionBoletoHostedVoucherUrl = GHC.Maybe.Nothing,
      paymentIntentNextActionBoletoNumber = GHC.Maybe.Nothing,
      paymentIntentNextActionBoletoPdf = GHC.Maybe.Nothing
    }
