{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentMethodDetailsInteracPresent
module StripeAPI.Types.PaymentMethodDetailsInteracPresent where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.PaymentMethodDetailsInteracPresentReceipt
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_method_details_interac_present@ in the specification.
data PaymentMethodDetailsInteracPresent = PaymentMethodDetailsInteracPresent
  { -- | brand: Card brand. Can be \`interac\`, \`mastercard\` or \`visa\`.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentBrand :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | cardholder_name: The cardholder name as read from the card, in [ISO 7813](https:\/\/en.wikipedia.org\/wiki\/ISO\/IEC_7813) format. May include alphanumeric characters, special characters and first\/last name separator (\`\/\`).
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentCardholderName :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | country: Two-letter ISO code representing the country of the card. You could use this attribute to get a sense of the international breakdown of cards you\'ve collected.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentCountry :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | emv_auth_data: Authorization response cryptogram.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentEmvAuthData :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | exp_month: Two-digit number representing the card\'s expiration month.
    paymentMethodDetailsInteracPresentExpMonth :: GHC.Types.Int,
    -- | exp_year: Four-digit number representing the card\'s expiration year.
    paymentMethodDetailsInteracPresentExpYear :: GHC.Types.Int,
    -- | fingerprint: Uniquely identifies this particular card number. You can use this attribute to check whether two customers who’ve signed up with you are using the same card number, for example. For payment methods that tokenize card information (Apple Pay, Google Pay), the tokenized number might be provided instead of the underlying card number.
    --
    -- *Starting May 1, 2021, card fingerprint in India for Connect will change to allow two fingerprints for the same card --- one for India and one for the rest of the world.*
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentFingerprint :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | funding: Card funding type. Can be \`credit\`, \`debit\`, \`prepaid\`, or \`unknown\`.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentFunding :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | generated_card: ID of a card PaymentMethod generated from the card_present PaymentMethod that may be attached to a Customer for future transactions. Only present if it was possible to generate a card PaymentMethod.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentGeneratedCard :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | last4: The last four digits of the card.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentLast4 :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | network: Identifies which network this charge was processed on. Can be \`amex\`, \`cartes_bancaires\`, \`diners\`, \`discover\`, \`interac\`, \`jcb\`, \`mastercard\`, \`unionpay\`, \`visa\`, or \`unknown\`.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentNetwork :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | preferred_locales: EMV tag 5F2D. Preferred languages specified by the integrated circuit chip.
    paymentMethodDetailsInteracPresentPreferredLocales :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | read_method: How card details were read in this transaction.
    paymentMethodDetailsInteracPresentReadMethod :: (GHC.Maybe.Maybe PaymentMethodDetailsInteracPresentReadMethod'),
    -- | receipt: A collection of fields required to be displayed on receipts. Only required for EMV transactions.
    paymentMethodDetailsInteracPresentReceipt :: (GHC.Maybe.Maybe PaymentMethodDetailsInteracPresentReceipt')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentMethodDetailsInteracPresent where
  toJSON obj = Data.Aeson.Types.Internal.object ("brand" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentBrand obj : "cardholder_name" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentCardholderName obj : "country" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentCountry obj : "emv_auth_data" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentEmvAuthData obj : "exp_month" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentExpMonth obj : "exp_year" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentExpYear obj : "fingerprint" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentFingerprint obj : "funding" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentFunding obj : "generated_card" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentGeneratedCard obj : "last4" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentLast4 obj : "network" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentNetwork obj : "preferred_locales" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentPreferredLocales obj : "read_method" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReadMethod obj : "receipt" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("brand" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentBrand obj) GHC.Base.<> (("cardholder_name" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentCardholderName obj) GHC.Base.<> (("country" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentCountry obj) GHC.Base.<> (("emv_auth_data" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentEmvAuthData obj) GHC.Base.<> (("exp_month" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentExpMonth obj) GHC.Base.<> (("exp_year" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentExpYear obj) GHC.Base.<> (("fingerprint" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentFingerprint obj) GHC.Base.<> (("funding" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentFunding obj) GHC.Base.<> (("generated_card" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentGeneratedCard obj) GHC.Base.<> (("last4" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentLast4 obj) GHC.Base.<> (("network" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentNetwork obj) GHC.Base.<> (("preferred_locales" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentPreferredLocales obj) GHC.Base.<> (("read_method" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReadMethod obj) GHC.Base.<> ("receipt" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt obj))))))))))))))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentMethodDetailsInteracPresent where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentMethodDetailsInteracPresent" (\obj -> (((((((((((((GHC.Base.pure PaymentMethodDetailsInteracPresent GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "brand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "cardholder_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "country")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "emv_auth_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "exp_month")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "exp_year")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "fingerprint")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "funding")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "generated_card")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "last4")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "network")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "preferred_locales")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "read_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "receipt"))

-- | Create a new 'PaymentMethodDetailsInteracPresent' with all required fields.
mkPaymentMethodDetailsInteracPresent ::
  -- | 'paymentMethodDetailsInteracPresentExpMonth'
  GHC.Types.Int ->
  -- | 'paymentMethodDetailsInteracPresentExpYear'
  GHC.Types.Int ->
  PaymentMethodDetailsInteracPresent
mkPaymentMethodDetailsInteracPresent paymentMethodDetailsInteracPresentExpMonth paymentMethodDetailsInteracPresentExpYear =
  PaymentMethodDetailsInteracPresent
    { paymentMethodDetailsInteracPresentBrand = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentCardholderName = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentCountry = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentEmvAuthData = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentExpMonth = paymentMethodDetailsInteracPresentExpMonth,
      paymentMethodDetailsInteracPresentExpYear = paymentMethodDetailsInteracPresentExpYear,
      paymentMethodDetailsInteracPresentFingerprint = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentFunding = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentGeneratedCard = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentLast4 = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentNetwork = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentPreferredLocales = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentReadMethod = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentReceipt = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.payment_method_details_interac_present.properties.read_method@ in the specification.
--
-- How card details were read in this transaction.
data PaymentMethodDetailsInteracPresentReadMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentMethodDetailsInteracPresentReadMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentMethodDetailsInteracPresentReadMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"contact_emv"@
    PaymentMethodDetailsInteracPresentReadMethod'EnumContactEmv
  | -- | Represents the JSON value @"contactless_emv"@
    PaymentMethodDetailsInteracPresentReadMethod'EnumContactlessEmv
  | -- | Represents the JSON value @"contactless_magstripe_mode"@
    PaymentMethodDetailsInteracPresentReadMethod'EnumContactlessMagstripeMode
  | -- | Represents the JSON value @"magnetic_stripe_fallback"@
    PaymentMethodDetailsInteracPresentReadMethod'EnumMagneticStripeFallback
  | -- | Represents the JSON value @"magnetic_stripe_track2"@
    PaymentMethodDetailsInteracPresentReadMethod'EnumMagneticStripeTrack2
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentMethodDetailsInteracPresentReadMethod' where
  toJSON (PaymentMethodDetailsInteracPresentReadMethod'Other val) = val
  toJSON (PaymentMethodDetailsInteracPresentReadMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentMethodDetailsInteracPresentReadMethod'EnumContactEmv) = "contact_emv"
  toJSON (PaymentMethodDetailsInteracPresentReadMethod'EnumContactlessEmv) = "contactless_emv"
  toJSON (PaymentMethodDetailsInteracPresentReadMethod'EnumContactlessMagstripeMode) = "contactless_magstripe_mode"
  toJSON (PaymentMethodDetailsInteracPresentReadMethod'EnumMagneticStripeFallback) = "magnetic_stripe_fallback"
  toJSON (PaymentMethodDetailsInteracPresentReadMethod'EnumMagneticStripeTrack2) = "magnetic_stripe_track2"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentMethodDetailsInteracPresentReadMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "contact_emv" -> PaymentMethodDetailsInteracPresentReadMethod'EnumContactEmv
            | val GHC.Classes.== "contactless_emv" -> PaymentMethodDetailsInteracPresentReadMethod'EnumContactlessEmv
            | val GHC.Classes.== "contactless_magstripe_mode" -> PaymentMethodDetailsInteracPresentReadMethod'EnumContactlessMagstripeMode
            | val GHC.Classes.== "magnetic_stripe_fallback" -> PaymentMethodDetailsInteracPresentReadMethod'EnumMagneticStripeFallback
            | val GHC.Classes.== "magnetic_stripe_track2" -> PaymentMethodDetailsInteracPresentReadMethod'EnumMagneticStripeTrack2
            | GHC.Base.otherwise -> PaymentMethodDetailsInteracPresentReadMethod'Other val
      )

-- | Defines the object schema located at @components.schemas.payment_method_details_interac_present.properties.receipt.anyOf@ in the specification.
--
-- A collection of fields required to be displayed on receipts. Only required for EMV transactions.
data PaymentMethodDetailsInteracPresentReceipt' = PaymentMethodDetailsInteracPresentReceipt'
  { -- | account_type: The type of account being debited or credited
    paymentMethodDetailsInteracPresentReceipt'AccountType :: (GHC.Maybe.Maybe PaymentMethodDetailsInteracPresentReceipt'AccountType'),
    -- | application_cryptogram: EMV tag 9F26, cryptogram generated by the integrated circuit chip.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentReceipt'ApplicationCryptogram :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | application_preferred_name: Mnenomic of the Application Identifier.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentReceipt'ApplicationPreferredName :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | authorization_code: Identifier for this transaction.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentReceipt'AuthorizationCode :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | authorization_response_code: EMV tag 8A. A code returned by the card issuer.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentReceipt'AuthorizationResponseCode :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | cardholder_verification_method: How the cardholder verified ownership of the card.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentReceipt'CardholderVerificationMethod :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | dedicated_file_name: EMV tag 84. Similar to the application identifier stored on the integrated circuit chip.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentReceipt'DedicatedFileName :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | terminal_verification_results: The outcome of a series of EMV functions performed by the card reader.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentReceipt'TerminalVerificationResults :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | transaction_status_information: An indication of various EMV functions performed during the transaction.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodDetailsInteracPresentReceipt'TransactionStatusInformation :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentMethodDetailsInteracPresentReceipt' where
  toJSON obj = Data.Aeson.Types.Internal.object ("account_type" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'AccountType obj : "application_cryptogram" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'ApplicationCryptogram obj : "application_preferred_name" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'ApplicationPreferredName obj : "authorization_code" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'AuthorizationCode obj : "authorization_response_code" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'AuthorizationResponseCode obj : "cardholder_verification_method" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'CardholderVerificationMethod obj : "dedicated_file_name" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'DedicatedFileName obj : "terminal_verification_results" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'TerminalVerificationResults obj : "transaction_status_information" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'TransactionStatusInformation obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("account_type" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'AccountType obj) GHC.Base.<> (("application_cryptogram" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'ApplicationCryptogram obj) GHC.Base.<> (("application_preferred_name" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'ApplicationPreferredName obj) GHC.Base.<> (("authorization_code" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'AuthorizationCode obj) GHC.Base.<> (("authorization_response_code" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'AuthorizationResponseCode obj) GHC.Base.<> (("cardholder_verification_method" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'CardholderVerificationMethod obj) GHC.Base.<> (("dedicated_file_name" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'DedicatedFileName obj) GHC.Base.<> (("terminal_verification_results" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'TerminalVerificationResults obj) GHC.Base.<> ("transaction_status_information" Data.Aeson.Types.ToJSON..= paymentMethodDetailsInteracPresentReceipt'TransactionStatusInformation obj)))))))))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentMethodDetailsInteracPresentReceipt' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentMethodDetailsInteracPresentReceipt'" (\obj -> ((((((((GHC.Base.pure PaymentMethodDetailsInteracPresentReceipt' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "account_type")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "application_cryptogram")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "application_preferred_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "authorization_code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "authorization_response_code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "cardholder_verification_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "dedicated_file_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "terminal_verification_results")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "transaction_status_information"))

-- | Create a new 'PaymentMethodDetailsInteracPresentReceipt'' with all required fields.
mkPaymentMethodDetailsInteracPresentReceipt' :: PaymentMethodDetailsInteracPresentReceipt'
mkPaymentMethodDetailsInteracPresentReceipt' =
  PaymentMethodDetailsInteracPresentReceipt'
    { paymentMethodDetailsInteracPresentReceipt'AccountType = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentReceipt'ApplicationCryptogram = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentReceipt'ApplicationPreferredName = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentReceipt'AuthorizationCode = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentReceipt'AuthorizationResponseCode = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentReceipt'CardholderVerificationMethod = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentReceipt'DedicatedFileName = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentReceipt'TerminalVerificationResults = GHC.Maybe.Nothing,
      paymentMethodDetailsInteracPresentReceipt'TransactionStatusInformation = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.payment_method_details_interac_present.properties.receipt.anyOf.properties.account_type@ in the specification.
--
-- The type of account being debited or credited
data PaymentMethodDetailsInteracPresentReceipt'AccountType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentMethodDetailsInteracPresentReceipt'AccountType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentMethodDetailsInteracPresentReceipt'AccountType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"checking"@
    PaymentMethodDetailsInteracPresentReceipt'AccountType'EnumChecking
  | -- | Represents the JSON value @"savings"@
    PaymentMethodDetailsInteracPresentReceipt'AccountType'EnumSavings
  | -- | Represents the JSON value @"unknown"@
    PaymentMethodDetailsInteracPresentReceipt'AccountType'EnumUnknown
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentMethodDetailsInteracPresentReceipt'AccountType' where
  toJSON (PaymentMethodDetailsInteracPresentReceipt'AccountType'Other val) = val
  toJSON (PaymentMethodDetailsInteracPresentReceipt'AccountType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentMethodDetailsInteracPresentReceipt'AccountType'EnumChecking) = "checking"
  toJSON (PaymentMethodDetailsInteracPresentReceipt'AccountType'EnumSavings) = "savings"
  toJSON (PaymentMethodDetailsInteracPresentReceipt'AccountType'EnumUnknown) = "unknown"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentMethodDetailsInteracPresentReceipt'AccountType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "checking" -> PaymentMethodDetailsInteracPresentReceipt'AccountType'EnumChecking
            | val GHC.Classes.== "savings" -> PaymentMethodDetailsInteracPresentReceipt'AccountType'EnumSavings
            | val GHC.Classes.== "unknown" -> PaymentMethodDetailsInteracPresentReceipt'AccountType'EnumUnknown
            | GHC.Base.otherwise -> PaymentMethodDetailsInteracPresentReceipt'AccountType'Other val
      )
