{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentPagesCheckoutSessionAutomaticTax
module StripeAPI.Types.PaymentPagesCheckoutSessionAutomaticTax where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_pages_checkout_session_automatic_tax@ in the specification.
data PaymentPagesCheckoutSessionAutomaticTax = PaymentPagesCheckoutSessionAutomaticTax
  { -- | enabled: Indicates whether automatic tax is enabled for the session
    paymentPagesCheckoutSessionAutomaticTaxEnabled :: GHC.Types.Bool,
    -- | status: The status of the most recent automated tax calculation for this session.
    paymentPagesCheckoutSessionAutomaticTaxStatus :: (GHC.Maybe.Maybe PaymentPagesCheckoutSessionAutomaticTaxStatus')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentPagesCheckoutSessionAutomaticTax where
  toJSON obj = Data.Aeson.Types.Internal.object ("enabled" Data.Aeson.Types.ToJSON..= paymentPagesCheckoutSessionAutomaticTaxEnabled obj : "status" Data.Aeson.Types.ToJSON..= paymentPagesCheckoutSessionAutomaticTaxStatus obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("enabled" Data.Aeson.Types.ToJSON..= paymentPagesCheckoutSessionAutomaticTaxEnabled obj) GHC.Base.<> ("status" Data.Aeson.Types.ToJSON..= paymentPagesCheckoutSessionAutomaticTaxStatus obj))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentPagesCheckoutSessionAutomaticTax where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentPagesCheckoutSessionAutomaticTax" (\obj -> (GHC.Base.pure PaymentPagesCheckoutSessionAutomaticTax GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "status"))

-- | Create a new 'PaymentPagesCheckoutSessionAutomaticTax' with all required fields.
mkPaymentPagesCheckoutSessionAutomaticTax ::
  -- | 'paymentPagesCheckoutSessionAutomaticTaxEnabled'
  GHC.Types.Bool ->
  PaymentPagesCheckoutSessionAutomaticTax
mkPaymentPagesCheckoutSessionAutomaticTax paymentPagesCheckoutSessionAutomaticTaxEnabled =
  PaymentPagesCheckoutSessionAutomaticTax
    { paymentPagesCheckoutSessionAutomaticTaxEnabled = paymentPagesCheckoutSessionAutomaticTaxEnabled,
      paymentPagesCheckoutSessionAutomaticTaxStatus = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.payment_pages_checkout_session_automatic_tax.properties.status@ in the specification.
--
-- The status of the most recent automated tax calculation for this session.
data PaymentPagesCheckoutSessionAutomaticTaxStatus'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentPagesCheckoutSessionAutomaticTaxStatus'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentPagesCheckoutSessionAutomaticTaxStatus'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"complete"@
    PaymentPagesCheckoutSessionAutomaticTaxStatus'EnumComplete
  | -- | Represents the JSON value @"failed"@
    PaymentPagesCheckoutSessionAutomaticTaxStatus'EnumFailed
  | -- | Represents the JSON value @"requires_location_inputs"@
    PaymentPagesCheckoutSessionAutomaticTaxStatus'EnumRequiresLocationInputs
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentPagesCheckoutSessionAutomaticTaxStatus' where
  toJSON (PaymentPagesCheckoutSessionAutomaticTaxStatus'Other val) = val
  toJSON (PaymentPagesCheckoutSessionAutomaticTaxStatus'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentPagesCheckoutSessionAutomaticTaxStatus'EnumComplete) = "complete"
  toJSON (PaymentPagesCheckoutSessionAutomaticTaxStatus'EnumFailed) = "failed"
  toJSON (PaymentPagesCheckoutSessionAutomaticTaxStatus'EnumRequiresLocationInputs) = "requires_location_inputs"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentPagesCheckoutSessionAutomaticTaxStatus' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "complete" -> PaymentPagesCheckoutSessionAutomaticTaxStatus'EnumComplete
            | val GHC.Classes.== "failed" -> PaymentPagesCheckoutSessionAutomaticTaxStatus'EnumFailed
            | val GHC.Classes.== "requires_location_inputs" -> PaymentPagesCheckoutSessionAutomaticTaxStatus'EnumRequiresLocationInputs
            | GHC.Base.otherwise -> PaymentPagesCheckoutSessionAutomaticTaxStatus'Other val
      )
