{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema IssuingCardAuthorizationControls
module StripeAPI.Types.IssuingCardAuthorizationControls where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.IssuingCardSpendingLimit
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.issuing_card_authorization_controls@ in the specification.
data IssuingCardAuthorizationControls = IssuingCardAuthorizationControls
  { -- | allowed_categories: Array of strings containing [categories](https:\/\/stripe.com\/docs\/api\#issuing_authorization_object-merchant_data-category) of authorizations to allow. All other categories will be blocked. Cannot be set with \`blocked_categories\`.
    issuingCardAuthorizationControlsAllowedCategories :: (GHC.Maybe.Maybe ([IssuingCardAuthorizationControlsAllowedCategories'])),
    -- | blocked_categories: Array of strings containing [categories](https:\/\/stripe.com\/docs\/api\#issuing_authorization_object-merchant_data-category) of authorizations to decline. All other categories will be allowed. Cannot be set with \`allowed_categories\`.
    issuingCardAuthorizationControlsBlockedCategories :: (GHC.Maybe.Maybe ([IssuingCardAuthorizationControlsBlockedCategories'])),
    -- | spending_limits: Limit spending with amount-based rules that apply across any cards this card replaced (i.e., its \`replacement_for\` card and _that_ card\'s \`replacement_for\` card, up the chain).
    issuingCardAuthorizationControlsSpendingLimits :: (GHC.Maybe.Maybe ([IssuingCardSpendingLimit])),
    -- | spending_limits_currency: Currency of the amounts within \`spending_limits\`. Always the same as the currency of the card.
    issuingCardAuthorizationControlsSpendingLimitsCurrency :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardAuthorizationControls where
  toJSON obj = Data.Aeson.Types.Internal.object ("allowed_categories" Data.Aeson.Types.ToJSON..= issuingCardAuthorizationControlsAllowedCategories obj : "blocked_categories" Data.Aeson.Types.ToJSON..= issuingCardAuthorizationControlsBlockedCategories obj : "spending_limits" Data.Aeson.Types.ToJSON..= issuingCardAuthorizationControlsSpendingLimits obj : "spending_limits_currency" Data.Aeson.Types.ToJSON..= issuingCardAuthorizationControlsSpendingLimitsCurrency obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("allowed_categories" Data.Aeson.Types.ToJSON..= issuingCardAuthorizationControlsAllowedCategories obj) GHC.Base.<> (("blocked_categories" Data.Aeson.Types.ToJSON..= issuingCardAuthorizationControlsBlockedCategories obj) GHC.Base.<> (("spending_limits" Data.Aeson.Types.ToJSON..= issuingCardAuthorizationControlsSpendingLimits obj) GHC.Base.<> ("spending_limits_currency" Data.Aeson.Types.ToJSON..= issuingCardAuthorizationControlsSpendingLimitsCurrency obj))))

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardAuthorizationControls where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "IssuingCardAuthorizationControls" (\obj -> (((GHC.Base.pure IssuingCardAuthorizationControls GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "allowed_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "blocked_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "spending_limits")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "spending_limits_currency"))

-- | Create a new 'IssuingCardAuthorizationControls' with all required fields.
mkIssuingCardAuthorizationControls :: IssuingCardAuthorizationControls
mkIssuingCardAuthorizationControls =
  IssuingCardAuthorizationControls
    { issuingCardAuthorizationControlsAllowedCategories = GHC.Maybe.Nothing,
      issuingCardAuthorizationControlsBlockedCategories = GHC.Maybe.Nothing,
      issuingCardAuthorizationControlsSpendingLimits = GHC.Maybe.Nothing,
      issuingCardAuthorizationControlsSpendingLimitsCurrency = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.issuing_card_authorization_controls.properties.allowed_categories.items@ in the specification.
data IssuingCardAuthorizationControlsAllowedCategories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    IssuingCardAuthorizationControlsAllowedCategories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    IssuingCardAuthorizationControlsAllowedCategories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    IssuingCardAuthorizationControlsAllowedCategories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardAuthorizationControlsAllowedCategories' where
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'Other val) = val
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAdvertisingServices) = "advertising_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAntiqueShops) = "antique_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAquariums) = "aquariums"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBakeries) = "bakeries"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBicycleShops) = "bicycle_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBoatDealers) = "boat_dealers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBookStores) = "book_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBusLines) = "bus_lines"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCarWashes) = "car_washes"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCarpentryServices) = "carpentry_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCaterers) = "caterers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumChildCareServices) = "child_care_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumChiropractors) = "chiropractors"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumClothingRental) = "clothing_rental"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumComputerProgramming) = "computer_programming"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumComputerRepair) = "computer_repair"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumConstructionMaterials) = "construction_materials"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCounselingServices) = "counseling_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCountryClubs) = "country_clubs"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCourierServices) = "courier_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCourtCosts) = "court_costs"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumCruiseLines) = "cruise_lines"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDepartmentStores) = "department_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDiscountStores) = "discount_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDoctors) = "doctors"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDryCleaners) = "dry_cleaners"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDurableGoods) = "durable_goods"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumEducationalServices) = "educational_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumElectricalServices) = "electrical_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumElectronicsStores) = "electronics_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumEquipmentRental) = "equipment_rental"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumExterminatingServices) = "exterminating_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFlorists) = "florists"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumGeneralServices) = "general_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumGovernmentServices) = "government_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumHardwareStores) = "hardware_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumHospitals) = "hospitals"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumInsuranceDefault) = "insurance_default"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumLandscapingServices) = "landscaping_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumLaundries) = "laundries"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMassageParlors) = "massage_parlors"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMedicalServices) = "medical_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneous) = "miscellaneous"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumOsteopaths) = "osteopaths"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPassengerRailways) = "passenger_railways"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPawnShops) = "pawn_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumProfessionalServices) = "professional_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumRailroads) = "railroads"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumRecordStores) = "record_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumServiceStations) = "service_stations"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumShoeStores) = "shoe_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTelegraphServices) = "telegraph_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTimeshares) = "timeshares"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTowingServices) = "towing_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTransportationServices) = "transportation_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumUtilities) = "utilities"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumVarietyStores) = "variety_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumWeldingRepair) = "welding_repair"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (IssuingCardAuthorizationControlsAllowedCategories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardAuthorizationControlsAllowedCategories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> IssuingCardAuthorizationControlsAllowedCategories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> IssuingCardAuthorizationControlsAllowedCategories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> IssuingCardAuthorizationControlsAllowedCategories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> IssuingCardAuthorizationControlsAllowedCategories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> IssuingCardAuthorizationControlsAllowedCategories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> IssuingCardAuthorizationControlsAllowedCategories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> IssuingCardAuthorizationControlsAllowedCategories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> IssuingCardAuthorizationControlsAllowedCategories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> IssuingCardAuthorizationControlsAllowedCategories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> IssuingCardAuthorizationControlsAllowedCategories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> IssuingCardAuthorizationControlsAllowedCategories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> IssuingCardAuthorizationControlsAllowedCategories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> IssuingCardAuthorizationControlsAllowedCategories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> IssuingCardAuthorizationControlsAllowedCategories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> IssuingCardAuthorizationControlsAllowedCategories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> IssuingCardAuthorizationControlsAllowedCategories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> IssuingCardAuthorizationControlsAllowedCategories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> IssuingCardAuthorizationControlsAllowedCategories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> IssuingCardAuthorizationControlsAllowedCategories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> IssuingCardAuthorizationControlsAllowedCategories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> IssuingCardAuthorizationControlsAllowedCategories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> IssuingCardAuthorizationControlsAllowedCategories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> IssuingCardAuthorizationControlsAllowedCategories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> IssuingCardAuthorizationControlsAllowedCategories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> IssuingCardAuthorizationControlsAllowedCategories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> IssuingCardAuthorizationControlsAllowedCategories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> IssuingCardAuthorizationControlsAllowedCategories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> IssuingCardAuthorizationControlsAllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> IssuingCardAuthorizationControlsAllowedCategories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> IssuingCardAuthorizationControlsAllowedCategories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> IssuingCardAuthorizationControlsAllowedCategories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> IssuingCardAuthorizationControlsAllowedCategories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> IssuingCardAuthorizationControlsAllowedCategories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> IssuingCardAuthorizationControlsAllowedCategories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> IssuingCardAuthorizationControlsAllowedCategories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> IssuingCardAuthorizationControlsAllowedCategories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> IssuingCardAuthorizationControlsAllowedCategories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> IssuingCardAuthorizationControlsAllowedCategories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> IssuingCardAuthorizationControlsAllowedCategories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> IssuingCardAuthorizationControlsAllowedCategories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> IssuingCardAuthorizationControlsAllowedCategories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> IssuingCardAuthorizationControlsAllowedCategories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> IssuingCardAuthorizationControlsAllowedCategories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> IssuingCardAuthorizationControlsAllowedCategories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> IssuingCardAuthorizationControlsAllowedCategories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> IssuingCardAuthorizationControlsAllowedCategories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> IssuingCardAuthorizationControlsAllowedCategories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> IssuingCardAuthorizationControlsAllowedCategories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> IssuingCardAuthorizationControlsAllowedCategories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> IssuingCardAuthorizationControlsAllowedCategories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> IssuingCardAuthorizationControlsAllowedCategories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> IssuingCardAuthorizationControlsAllowedCategories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> IssuingCardAuthorizationControlsAllowedCategories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> IssuingCardAuthorizationControlsAllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> IssuingCardAuthorizationControlsAllowedCategories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> IssuingCardAuthorizationControlsAllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> IssuingCardAuthorizationControlsAllowedCategories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> IssuingCardAuthorizationControlsAllowedCategories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> IssuingCardAuthorizationControlsAllowedCategories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> IssuingCardAuthorizationControlsAllowedCategories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> IssuingCardAuthorizationControlsAllowedCategories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> IssuingCardAuthorizationControlsAllowedCategories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> IssuingCardAuthorizationControlsAllowedCategories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> IssuingCardAuthorizationControlsAllowedCategories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> IssuingCardAuthorizationControlsAllowedCategories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> IssuingCardAuthorizationControlsAllowedCategories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> IssuingCardAuthorizationControlsAllowedCategories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> IssuingCardAuthorizationControlsAllowedCategories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> IssuingCardAuthorizationControlsAllowedCategories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> IssuingCardAuthorizationControlsAllowedCategories'Other val
      )

-- | Defines the enum schema located at @components.schemas.issuing_card_authorization_controls.properties.blocked_categories.items@ in the specification.
data IssuingCardAuthorizationControlsBlockedCategories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    IssuingCardAuthorizationControlsBlockedCategories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    IssuingCardAuthorizationControlsBlockedCategories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    IssuingCardAuthorizationControlsBlockedCategories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardAuthorizationControlsBlockedCategories' where
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'Other val) = val
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAdvertisingServices) = "advertising_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAntiqueShops) = "antique_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAquariums) = "aquariums"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBakeries) = "bakeries"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBicycleShops) = "bicycle_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBoatDealers) = "boat_dealers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBookStores) = "book_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBusLines) = "bus_lines"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCarWashes) = "car_washes"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCarpentryServices) = "carpentry_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCaterers) = "caterers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumChildCareServices) = "child_care_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumChiropractors) = "chiropractors"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumClothingRental) = "clothing_rental"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumComputerProgramming) = "computer_programming"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumComputerRepair) = "computer_repair"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumConstructionMaterials) = "construction_materials"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCounselingServices) = "counseling_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCountryClubs) = "country_clubs"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCourierServices) = "courier_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCourtCosts) = "court_costs"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumCruiseLines) = "cruise_lines"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDepartmentStores) = "department_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDiscountStores) = "discount_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDoctors) = "doctors"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDryCleaners) = "dry_cleaners"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDurableGoods) = "durable_goods"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumEducationalServices) = "educational_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumElectricalServices) = "electrical_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumElectronicsStores) = "electronics_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumEquipmentRental) = "equipment_rental"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumExterminatingServices) = "exterminating_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFlorists) = "florists"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumGeneralServices) = "general_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumGovernmentServices) = "government_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumHardwareStores) = "hardware_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumHospitals) = "hospitals"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumInsuranceDefault) = "insurance_default"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumLandscapingServices) = "landscaping_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumLaundries) = "laundries"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMassageParlors) = "massage_parlors"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMedicalServices) = "medical_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneous) = "miscellaneous"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumOsteopaths) = "osteopaths"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPassengerRailways) = "passenger_railways"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPawnShops) = "pawn_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumProfessionalServices) = "professional_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumRailroads) = "railroads"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumRecordStores) = "record_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumServiceStations) = "service_stations"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumShoeStores) = "shoe_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTelegraphServices) = "telegraph_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTimeshares) = "timeshares"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTowingServices) = "towing_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTransportationServices) = "transportation_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumUtilities) = "utilities"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumVarietyStores) = "variety_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumWeldingRepair) = "welding_repair"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (IssuingCardAuthorizationControlsBlockedCategories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardAuthorizationControlsBlockedCategories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> IssuingCardAuthorizationControlsBlockedCategories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> IssuingCardAuthorizationControlsBlockedCategories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> IssuingCardAuthorizationControlsBlockedCategories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> IssuingCardAuthorizationControlsBlockedCategories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> IssuingCardAuthorizationControlsBlockedCategories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> IssuingCardAuthorizationControlsBlockedCategories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> IssuingCardAuthorizationControlsBlockedCategories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> IssuingCardAuthorizationControlsBlockedCategories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> IssuingCardAuthorizationControlsBlockedCategories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> IssuingCardAuthorizationControlsBlockedCategories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> IssuingCardAuthorizationControlsBlockedCategories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> IssuingCardAuthorizationControlsBlockedCategories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> IssuingCardAuthorizationControlsBlockedCategories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> IssuingCardAuthorizationControlsBlockedCategories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> IssuingCardAuthorizationControlsBlockedCategories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> IssuingCardAuthorizationControlsBlockedCategories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> IssuingCardAuthorizationControlsBlockedCategories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> IssuingCardAuthorizationControlsBlockedCategories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> IssuingCardAuthorizationControlsBlockedCategories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> IssuingCardAuthorizationControlsBlockedCategories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> IssuingCardAuthorizationControlsBlockedCategories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> IssuingCardAuthorizationControlsBlockedCategories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> IssuingCardAuthorizationControlsBlockedCategories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> IssuingCardAuthorizationControlsBlockedCategories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> IssuingCardAuthorizationControlsBlockedCategories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> IssuingCardAuthorizationControlsBlockedCategories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> IssuingCardAuthorizationControlsBlockedCategories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> IssuingCardAuthorizationControlsBlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> IssuingCardAuthorizationControlsBlockedCategories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> IssuingCardAuthorizationControlsBlockedCategories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> IssuingCardAuthorizationControlsBlockedCategories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> IssuingCardAuthorizationControlsBlockedCategories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> IssuingCardAuthorizationControlsBlockedCategories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> IssuingCardAuthorizationControlsBlockedCategories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> IssuingCardAuthorizationControlsBlockedCategories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> IssuingCardAuthorizationControlsBlockedCategories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> IssuingCardAuthorizationControlsBlockedCategories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> IssuingCardAuthorizationControlsBlockedCategories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> IssuingCardAuthorizationControlsBlockedCategories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> IssuingCardAuthorizationControlsBlockedCategories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> IssuingCardAuthorizationControlsBlockedCategories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> IssuingCardAuthorizationControlsBlockedCategories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> IssuingCardAuthorizationControlsBlockedCategories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> IssuingCardAuthorizationControlsBlockedCategories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> IssuingCardAuthorizationControlsBlockedCategories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> IssuingCardAuthorizationControlsBlockedCategories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> IssuingCardAuthorizationControlsBlockedCategories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> IssuingCardAuthorizationControlsBlockedCategories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> IssuingCardAuthorizationControlsBlockedCategories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> IssuingCardAuthorizationControlsBlockedCategories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> IssuingCardAuthorizationControlsBlockedCategories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> IssuingCardAuthorizationControlsBlockedCategories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> IssuingCardAuthorizationControlsBlockedCategories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> IssuingCardAuthorizationControlsBlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> IssuingCardAuthorizationControlsBlockedCategories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> IssuingCardAuthorizationControlsBlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> IssuingCardAuthorizationControlsBlockedCategories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> IssuingCardAuthorizationControlsBlockedCategories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> IssuingCardAuthorizationControlsBlockedCategories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> IssuingCardAuthorizationControlsBlockedCategories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> IssuingCardAuthorizationControlsBlockedCategories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> IssuingCardAuthorizationControlsBlockedCategories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> IssuingCardAuthorizationControlsBlockedCategories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> IssuingCardAuthorizationControlsBlockedCategories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> IssuingCardAuthorizationControlsBlockedCategories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> IssuingCardAuthorizationControlsBlockedCategories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> IssuingCardAuthorizationControlsBlockedCategories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> IssuingCardAuthorizationControlsBlockedCategories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> IssuingCardAuthorizationControlsBlockedCategories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> IssuingCardAuthorizationControlsBlockedCategories'Other val
      )
